#ifndef HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */

#include <tarot.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

int
main ()
{
  tarot_set_datadir (DATADIR);
  if (tarot_init (LOCALEDIR) != 0)
    {
      fprintf (stderr, "Error: could not load libtarot.\n");
      return EXIT_FAILURE;
    }
  {
    TarotGame *game = tarot_game_alloc ();
    TarotGameEvent *event = NULL;
    (void) event;
    event = tarot_game_event_alloc_setup (3, 0);
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      const TarotPlayer player = tarot_string_to_player_c ("P2");
      TarotCard cards[24];
      size_t i = 0;
      assert (player != ((TarotPlayer) (-1)));
      cards[i] = tarot_string_to_card_c ("7H");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("JH");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("CH");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("7C");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("9C");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("KC");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("4D");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("6D");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("8D");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("9D");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("10D");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("JD");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("AS");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("2S");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("7S");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("JS");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("QS");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("3T");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("7T");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("8T");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("9T");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("10T");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("13T");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      cards[i] = tarot_string_to_card_c ("16T");
      assert (cards[i] != ((TarotCard) (-1)));
      i++;
      event = tarot_game_event_alloc_deal (player, sizeof (cards) / sizeof (cards[0]), cards);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    event = tarot_game_event_alloc_bid (TAROT_DOUBLE_KEEP);
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    event = tarot_game_event_alloc_decl (0);
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    event = tarot_game_event_alloc_decl (0);
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    event = tarot_game_event_alloc_decl (0);
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard cards[0];
      size_t i = 0;
      (void) i;
      event = tarot_game_event_alloc_handful (sizeof (cards) / sizeof (cards[0]), cards);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("4H");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard cards[0];
      size_t i = 0;
      (void) i;
      event = tarot_game_event_alloc_handful (sizeof (cards) / sizeof (cards[0]), cards);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("7H");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard cards[0];
      size_t i = 0;
      (void) i;
      event = tarot_game_event_alloc_handful (sizeof (cards) / sizeof (cards[0]), cards);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("AH");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("KC");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("AC");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("2C");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("7C");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("3S");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("QC");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("5H");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("CH");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("2H");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    {
      TarotCard card = tarot_string_to_card_c ("9C");
      assert (card != ((TarotCard) (-1)));
      event = tarot_game_event_alloc_card (card);
    }
    if (tarot_game_add_event (game, event) != TAROT_GAME_OK)
      {
        fprintf (stderr, "%s:%d: Error: could not add the event.", __FILE__, __LINE__);
        return EXIT_FAILURE;
      }
    tarot_game_event_free (event);
    /* Now running the tests */
    tarot_game_free (game);
  }
  tarot_quit ();
  return EXIT_SUCCESS;
}