#include <config.h>
#include <tarot.h>
#include <libguile.h>
#define DECLARE_ARRAY_ACCESSOR(type, ctype) static inline SCM scm_from_array_##type (size_t n, ctype *values) { size_t i; SCM ret = SCM_EOL; for (i = 0; i < n; i++) ret = scm_cons (scm_from_##type (values[i]), ret); free (values); return scm_reverse (ret); } static inline ctype *scm_to_array_##type (size_t *n, SCM values) {size_t i; *n = scm_to_size_t (scm_length (values)); ctype *ret = scm_gc_malloc (*n * sizeof (ctype), "tarot"); for (i = 0; i < *n && scm_is_pair (values); i++, values = scm_cdr (values)) ret[i] = scm_to_##type (scm_car (values)); return ret;}
static inline SCM
scm_from_narrow_string (const char *value)
{
  size_t i = 0;
  size_t n = strlen (value);
  SCM ret = scm_c_make_bytevector (n);
  for (i = 0; i < n; i++)
    scm_c_bytevector_set_x (ret, i, value[i]);
  return ret;
}

static inline char *
scm_to_narrow_string (SCM value)
{
  size_t n = scm_to_size_t (scm_bytevector_length (value));
  char *ret = scm_gc_malloc (n + 1, "a string");
  size_t i = 0;
  for (i = 0; i < n; i++)
    ret[i] = scm_c_bytevector_ref (value, i);
  return ret;
}

#define scm_to_unowned_pointer(ptr) scm_to_pointer (ptr)
#define scm_from_unowned_pointer(ptr) scm_from_pointer (ptr, NULL)
DECLARE_ARRAY_ACCESSOR (char, char)
DECLARE_ARRAY_ACCESSOR (bool, int)
DECLARE_ARRAY_ACCESSOR (int, int)
DECLARE_ARRAY_ACCESSOR (size_t, size_t)
DECLARE_ARRAY_ACCESSOR (double, double)
DECLARE_ARRAY_ACCESSOR (unowned_pointer, void *)
#define scm_to_array_pointer(n, lst) (void *) scm_to_array_unowned_pointer (n, lst)
#define scm_from_array_pointer(n, ptr) scm_from_array_unowned_pointer (n, ptr)
     static inline SCM scm_from_typedef_Card (TarotCard value)
{
  return scm_from_uint (value);
}

static inline TarotCard
scm_to_typedef_Card (SCM value)
{
  return scm_to_uint (value);
}

DECLARE_ARRAY_ACCESSOR (typedef_Card, TarotCard)
     static inline SCM scm_from_typedef_Number (TarotNumber value)
{
  return scm_from_uint (value);
}

static inline TarotNumber
scm_to_typedef_Number (SCM value)
{
  return scm_to_uint (value);
}

DECLARE_ARRAY_ACCESSOR (typedef_Number, TarotNumber)
     static inline SCM scm_from_typedef_Player (TarotPlayer value)
{
  return scm_from_uint (value);
}

static inline TarotPlayer
scm_to_typedef_Player (SCM value)
{
  return scm_to_uint (value);
}

DECLARE_ARRAY_ACCESSOR (typedef_Player, TarotPlayer)
     static void free_class_Ai (void *data)
{
  tarot_ai_free ((TarotAi *) data);
} static inline SCM

scm_from_class_Ai (const TarotAi * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_Ai);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_enum_Bid (TarotBid value)
{
  switch (value)
    {
    case TAROT_PASS:
      return scm_from_utf8_symbol ("pass");
      break;
    case TAROT_TAKE:
      return scm_from_utf8_symbol ("take");
      break;
    case TAROT_PUSH:
      return scm_from_utf8_symbol ("push");
      break;
    case TAROT_STRAIGHT_KEEP:
      return scm_from_utf8_symbol ("straight-keep");
      break;
    case TAROT_DOUBLE_KEEP:
      return scm_from_utf8_symbol ("double-keep");
      break;
    }
  abort ();
}

static inline TarotBid
scm_to_enum_Bid (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("pass"))))
    {
      return TAROT_PASS;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("take"))))
    {
      return TAROT_TAKE;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("push"))))
    {
      return TAROT_PUSH;
    }
  else
    if (scm_to_bool
	(scm_eq_p (value, scm_from_utf8_symbol ("straight-keep"))))
    {
      return TAROT_STRAIGHT_KEEP;
    }
  else
    if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("double-keep"))))
    {
      return TAROT_DOUBLE_KEEP;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_Bid, TarotBid)
     static inline SCM scm_from_struct_Collision (TarotCollision value)
{
  return scm_list_n (scm_from_double (value.x), scm_from_double (value.y),
		     scm_from_size_t (value.card_index), SCM_UNDEFINED);
}

static inline TarotCollision
scm_to_struct_Collision (SCM value)
{
  TarotCollision ret;
  ret.x = scm_to_double (scm_car (value));
  value = scm_cdr (value);
  ret.y = scm_to_double (scm_car (value));
  value = scm_cdr (value);
  ret.card_index = scm_to_size_t (scm_car (value));
  value = scm_cdr (value);
  return ret;
}

DECLARE_ARRAY_ACCESSOR (struct_Collision, TarotCollision)
     static void free_class_Counter (void *data)
{
  tarot_counter_free ((TarotCounter *) data);
} static inline SCM

scm_from_class_Counter (const TarotCounter * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_Counter);
    }
  return scm_from_pointer ((void *) value, NULL);
} static void

free_class_Game (void *data)
{
  tarot_game_free ((TarotGame *) data);
} static inline SCM

scm_from_class_Game (const TarotGame * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_Game);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_struct_GameCardAnalysis (TarotGameCardAnalysis value)
{
  return scm_list_n (scm_from_typedef_Card (value.card),
		     scm_from_int (value.cannot_follow),
		     scm_from_int (value.cannot_overtrump),
		     scm_from_int (value.cannot_undertrump), SCM_UNDEFINED);
}

static inline TarotGameCardAnalysis
scm_to_struct_GameCardAnalysis (SCM value)
{
  TarotGameCardAnalysis ret;
  ret.card = scm_to_typedef_Card (scm_car (value));
  value = scm_cdr (value);
  ret.cannot_follow = scm_to_int (scm_car (value));
  value = scm_cdr (value);
  ret.cannot_overtrump = scm_to_int (scm_car (value));
  value = scm_cdr (value);
  ret.cannot_undertrump = scm_to_int (scm_car (value));
  value = scm_cdr (value);
  return ret;
}

DECLARE_ARRAY_ACCESSOR (struct_GameCardAnalysis, TarotGameCardAnalysis)
     static inline SCM scm_from_enum_GameError (TarotGameError value)
{
  switch (value)
    {
    case TAROT_GAME_OK:
      return scm_from_utf8_symbol ("ok");
      break;
    case TAROT_GAME_INVXML:
      return scm_from_utf8_symbol ("invxml");
      break;
    case TAROT_GAME_INVEV:
      return scm_from_utf8_symbol ("invev");
      break;
    case TAROT_GAME_NA:
      return scm_from_utf8_symbol ("na");
      break;
    case TAROT_GAME_TOOLATE:
      return scm_from_utf8_symbol ("toolate");
      break;
    }
  abort ();
}

static inline TarotGameError
scm_to_enum_GameError (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("ok"))))
    {
      return TAROT_GAME_OK;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("invxml"))))
    {
      return TAROT_GAME_INVXML;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("invev"))))
    {
      return TAROT_GAME_INVEV;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("na"))))
    {
      return TAROT_GAME_NA;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("toolate"))))
    {
      return TAROT_GAME_TOOLATE;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_GameError, TarotGameError)
     static void free_class_GameEvent (void *data)
{
  tarot_game_event_free ((TarotGameEvent *) data);
} static inline SCM

scm_from_class_GameEvent (const TarotGameEvent * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_GameEvent);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_enum_GameEventError (TarotGameEventError value)
{
  switch (value)
    {
    case TAROT_EVENT_OK:
      return scm_from_utf8_symbol ("ok");
      break;
    case TAROT_EVENT_ERRTP:
      return scm_from_utf8_symbol ("errtp");
      break;
    }
  abort ();
}

static inline TarotGameEventError
scm_to_enum_GameEventError (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("ok"))))
    {
      return TAROT_EVENT_OK;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("errtp"))))
    {
      return TAROT_EVENT_ERRTP;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_GameEventError, TarotGameEventError)
     static inline SCM scm_from_enum_GameEventT (TarotGameEventT value)
{
  switch (value)
    {
    case TAROT_SETUP_EVENT:
      return scm_from_utf8_symbol ("setup-event");
      break;
    case TAROT_DEAL_EVENT:
      return scm_from_utf8_symbol ("deal-event");
      break;
    case TAROT_DEAL_ALL_EVENT:
      return scm_from_utf8_symbol ("deal-all-event");
      break;
    case TAROT_BID_EVENT:
      return scm_from_utf8_symbol ("bid-event");
      break;
    case TAROT_DECL_EVENT:
      return scm_from_utf8_symbol ("decl-event");
      break;
    case TAROT_CALL_EVENT:
      return scm_from_utf8_symbol ("call-event");
      break;
    case TAROT_DOG_EVENT:
      return scm_from_utf8_symbol ("dog-event");
      break;
    case TAROT_DISCARD_EVENT:
      return scm_from_utf8_symbol ("discard-event");
      break;
    case TAROT_HANDFUL_EVENT:
      return scm_from_utf8_symbol ("handful-event");
      break;
    case TAROT_CARD_EVENT:
      return scm_from_utf8_symbol ("card-event");
      break;
    }
  abort ();
}

static inline TarotGameEventT
scm_to_enum_GameEventT (SCM value)
{
  if (0)
    {
    }
  else
    if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("setup-event"))))
    {
      return TAROT_SETUP_EVENT;
    }
  else
    if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("deal-event"))))
    {
      return TAROT_DEAL_EVENT;
    }
  else
    if (scm_to_bool
	(scm_eq_p (value, scm_from_utf8_symbol ("deal-all-event"))))
    {
      return TAROT_DEAL_ALL_EVENT;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("bid-event"))))
    {
      return TAROT_BID_EVENT;
    }
  else
    if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("decl-event"))))
    {
      return TAROT_DECL_EVENT;
    }
  else
    if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("call-event"))))
    {
      return TAROT_CALL_EVENT;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("dog-event"))))
    {
      return TAROT_DOG_EVENT;
    }
  else
    if (scm_to_bool
	(scm_eq_p (value, scm_from_utf8_symbol ("discard-event"))))
    {
      return TAROT_DISCARD_EVENT;
    }
  else
    if (scm_to_bool
	(scm_eq_p (value, scm_from_utf8_symbol ("handful-event"))))
    {
      return TAROT_HANDFUL_EVENT;
    }
  else
    if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("card-event"))))
    {
      return TAROT_CARD_EVENT;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_GameEventT, TarotGameEventT)
     static void free_class_GameIterator (void *data)
{
  tarot_game_iterator_free ((TarotGameIterator *) data);
} static inline SCM

scm_from_class_GameIterator (const TarotGameIterator * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_GameIterator);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_enum_ImputationError (TarotImputationError value)
{
  switch (value)
    {
    case TAROT_IMPUTATION_OK:
      return scm_from_utf8_symbol ("ok");
      break;
    case TAROT_IMPUTATION_FAILED:
      return scm_from_utf8_symbol ("failed");
      break;
    }
  abort ();
}

static inline TarotImputationError
scm_to_enum_ImputationError (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("ok"))))
    {
      return TAROT_IMPUTATION_OK;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("failed"))))
    {
      return TAROT_IMPUTATION_FAILED;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_ImputationError, TarotImputationError)
     static void free_class_Mcts (void *data)
{
  tarot_mcts_free ((TarotMcts *) data);
} static inline SCM

scm_from_class_Mcts (const TarotMcts * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_Mcts);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_enum_MctsError (TarotMctsError value)
{
  switch (value)
    {
    case TAROT_MCTS_OK:
      return scm_from_utf8_symbol ("ok");
      break;
    case TAROT_MCTS_NONEXT:
      return scm_from_utf8_symbol ("nonext");
      break;
    case TAROT_MCTS_UNKNOWNNEXT:
      return scm_from_utf8_symbol ("unknownnext");
      break;
    case TAROT_MCTS_NODATA:
      return scm_from_utf8_symbol ("nodata");
      break;
    case TAROT_MCTS_NOMEM:
      return scm_from_utf8_symbol ("nomem");
      break;
    }
  abort ();
}

static inline TarotMctsError
scm_to_enum_MctsError (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("ok"))))
    {
      return TAROT_MCTS_OK;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("nonext"))))
    {
      return TAROT_MCTS_NONEXT;
    }
  else
    if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("unknownnext"))))
    {
      return TAROT_MCTS_UNKNOWNNEXT;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("nodata"))))
    {
      return TAROT_MCTS_NODATA;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("nomem"))))
    {
      return TAROT_MCTS_NOMEM;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_MctsError, TarotMctsError)
     static void free_class_Perceptron (void *data)
{
  tarot_perceptron_free ((TarotPerceptron *) data);
} static inline SCM

scm_from_class_Perceptron (const TarotPerceptron * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_Perceptron);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_struct_Position (TarotPosition value)
{
  return scm_list_n (scm_from_double (value.x), scm_from_double (value.y),
		     scm_from_double (value.z), scm_from_double (value.scale),
		     scm_from_double (value.angle), SCM_UNDEFINED);
}

static inline TarotPosition
scm_to_struct_Position (SCM value)
{
  TarotPosition ret;
  ret.x = scm_to_double (scm_car (value));
  value = scm_cdr (value);
  ret.y = scm_to_double (scm_car (value));
  value = scm_cdr (value);
  ret.z = scm_to_double (scm_car (value));
  value = scm_cdr (value);
  ret.scale = scm_to_double (scm_car (value));
  value = scm_cdr (value);
  ret.angle = scm_to_double (scm_car (value));
  value = scm_cdr (value);
  return ret;
}

DECLARE_ARRAY_ACCESSOR (struct_Position, TarotPosition)
     static void free_class_Predictor (void *data)
{
  tarot_predictor_free ((TarotPredictor *) data);
} static inline SCM

scm_from_class_Predictor (const TarotPredictor * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_Predictor);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_enum_SimulationError (TarotSimulationError value)
{
  switch (value)
    {
    case TAROT_SIMULATION_OK:
      return scm_from_utf8_symbol ("ok");
      break;
    case TAROT_SIMULATION_INVSEED:
      return scm_from_utf8_symbol ("invseed");
      break;
    }
  abort ();
}

static inline TarotSimulationError
scm_to_enum_SimulationError (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("ok"))))
    {
      return TAROT_SIMULATION_OK;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("invseed"))))
    {
      return TAROT_SIMULATION_INVSEED;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_SimulationError, TarotSimulationError)
     static void free_class_Solo (void *data)
{
  tarot_solo_free ((TarotSolo *) data);
} static inline SCM

scm_from_class_Solo (const TarotSolo * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_Solo);
    }
  return scm_from_pointer ((void *) value, NULL);
} static inline SCM

scm_from_enum_Step (TarotStep value)
{
  switch (value)
    {
    case TAROT_SETUP:
      return scm_from_utf8_symbol ("setup");
      break;
    case TAROT_DEAL:
      return scm_from_utf8_symbol ("deal");
      break;
    case TAROT_BIDS:
      return scm_from_utf8_symbol ("bids");
      break;
    case TAROT_DECLS:
      return scm_from_utf8_symbol ("decls");
      break;
    case TAROT_CALL:
      return scm_from_utf8_symbol ("call");
      break;
    case TAROT_DOG:
      return scm_from_utf8_symbol ("dog");
      break;
    case TAROT_DISCARD:
      return scm_from_utf8_symbol ("discard");
      break;
    case TAROT_TRICKS:
      return scm_from_utf8_symbol ("tricks");
      break;
    case TAROT_END:
      return scm_from_utf8_symbol ("end");
      break;
    }
  abort ();
}

static inline TarotStep
scm_to_enum_Step (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("setup"))))
    {
      return TAROT_SETUP;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("deal"))))
    {
      return TAROT_DEAL;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("bids"))))
    {
      return TAROT_BIDS;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("decls"))))
    {
      return TAROT_DECLS;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("call"))))
    {
      return TAROT_CALL;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("dog"))))
    {
      return TAROT_DOG;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("discard"))))
    {
      return TAROT_DISCARD;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("tricks"))))
    {
      return TAROT_TRICKS;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("end"))))
    {
      return TAROT_END;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_Step, TarotStep)
     static inline SCM scm_from_enum_Suit (TarotSuit value)
{
  switch (value)
    {
    case TAROT_HEARTS:
      return scm_from_utf8_symbol ("hearts");
      break;
    case TAROT_CLUBS:
      return scm_from_utf8_symbol ("clubs");
      break;
    case TAROT_DIAMONDS:
      return scm_from_utf8_symbol ("diamonds");
      break;
    case TAROT_SPADES:
      return scm_from_utf8_symbol ("spades");
      break;
    case TAROT_TRUMPS:
      return scm_from_utf8_symbol ("trumps");
      break;
    }
  abort ();
}

static inline TarotSuit
scm_to_enum_Suit (SCM value)
{
  if (0)
    {
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("hearts"))))
    {
      return TAROT_HEARTS;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("clubs"))))
    {
      return TAROT_CLUBS;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("diamonds"))))
    {
      return TAROT_DIAMONDS;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("spades"))))
    {
      return TAROT_SPADES;
    }
  else if (scm_to_bool (scm_eq_p (value, scm_from_utf8_symbol ("trumps"))))
    {
      return TAROT_TRUMPS;
    }
  scm_throw (scm_from_utf8_symbol ("invalid-argument"), SCM_EOL);
  abort ();
}

DECLARE_ARRAY_ACCESSOR (enum_Suit, TarotSuit)
     static void free_class_XmlParser (void *data)
{
  tarot_xml_parser_free ((TarotXmlParser *) data);
} static inline SCM

scm_from_class_XmlParser (const TarotXmlParser * value, int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_XmlParser);
    }
  return scm_from_pointer ((void *) value, NULL);
} static void

free_class_XmlParserIterator (void *data)
{
  tarot_xml_parser_iterator_free ((TarotXmlParserIterator *) data);
} static inline SCM

scm_from_class_XmlParserIterator (const TarotXmlParserIterator * value,
				  int transfer)
{
  if (transfer)
    {
      return scm_from_pointer ((void *) value, free_class_XmlParserIterator);
    }
  return scm_from_pointer ((void *) value, NULL);
} static SCM

tarot_guile_tarot_ai_alloc_fuzzy (SCM g_fuzziness, SCM g_seed, SCM g_base)
{
/* Declaration of the types for input parameters */
  double c_fuzziness;
  size_t c_seed_size;
  char *c_seed;
  TarotAi *c_base;
/* Declaration of the type for the return value */
  TarotAi *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_fuzziness = scm_to_double (g_fuzziness);
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
  c_base = scm_to_pointer (g_base);
/* Calling the function */
  c_ret =
    (TarotAi *) tarot_ai_alloc_fuzzy (c_fuzziness, c_seed_size, c_seed,
				      c_base);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Ai (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_alloc_perceptron ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  TarotAi *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (TarotAi *) tarot_ai_alloc_perceptron ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Ai (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_alloc_random (SCM g_seed)
{
/* Declaration of the types for input parameters */
  size_t c_seed_size;
  char *c_seed;
/* Declaration of the type for the return value */
  TarotAi *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
/* Calling the function */
  c_ret = (TarotAi *) tarot_ai_alloc_random (c_seed_size, c_seed);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Ai (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_best (SCM g_ai, SCM g_state)
{
/* Declaration of the types for input parameters */
  TarotAi *c_ai;
  TarotGame *c_state;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */
  double c_score = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_ai = scm_to_pointer (g_ai);
  c_state = scm_to_pointer (g_state);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_ai_best (c_ai, c_state, &c_score);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 0), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_double (c_score), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_dup (SCM g_ai)
{
/* Declaration of the types for input parameters */
  TarotAi *c_ai;
/* Declaration of the type for the return value */
  TarotAi *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_ai = scm_to_pointer (g_ai);
/* Calling the function */
  c_ret = (TarotAi *) tarot_ai_dup (c_ai);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Ai (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_eval (SCM g_ai, SCM g_base, SCM g_candidates,
			   SCM g_start, SCM g_scores)
{
/* Declaration of the types for input parameters */
  TarotAi *c_ai;
  TarotGame *c_base;
  size_t c_n_candidates;
  TarotGameEvent **c_candidates;
  size_t c_start;
  size_t c_max;
  double *c_scores;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_ai = scm_to_pointer (g_ai);
  c_base = scm_to_pointer (g_base);
  c_candidates = scm_to_array_pointer (&c_n_candidates, g_candidates);
  c_start = scm_to_size_t (g_start);
  c_scores = scm_to_array_double (&c_max, g_scores);
/* Calling the function */
  tarot_ai_eval (c_ai, c_base, c_n_candidates, c_candidates, c_start, c_max,
		 c_scores);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_learn (SCM g_ai, SCM g_base, SCM g_event,
			    SCM g_final_score)
{
/* Declaration of the types for input parameters */
  TarotAi *c_ai;
  TarotGame *c_base;
  TarotGameEvent *c_event;
  double c_final_score;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_ai = scm_to_pointer (g_ai);
  c_base = scm_to_pointer (g_base);
  c_event = scm_to_pointer (g_event);
  c_final_score = scm_to_double (g_final_score);
/* Calling the function */
  tarot_ai_learn (c_ai, c_base, c_event, c_final_score);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_strongest_player (SCM g_ai, SCM g_n_players,
				       SCM g_with_call, SCM g_owners)
{
/* Declaration of the types for input parameters */
  TarotAi *c_ai;
  size_t c_n_players;
  int c_with_call;
  size_t c_n_cards;
  TarotPlayer *c_owners;
/* Declaration of the type for the return value */
  TarotPlayer c_ret;
/* Declaration of the types for output parameters */
  double c_confidence = 0;
  TarotCard c_call = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_ai = scm_to_pointer (g_ai);
  c_n_players = scm_to_size_t (g_n_players);
  c_with_call = scm_to_int (g_with_call);
  c_owners = scm_to_array_typedef_Player (&c_n_cards, g_owners);
/* Calling the function */
  c_ret =
    (TarotPlayer) tarot_ai_strongest_player (c_ai, c_n_players, c_with_call,
					     c_n_cards, c_owners,
					     &c_confidence, &c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Player (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_double (c_confidence), g_ret);
  g_ret = scm_cons (scm_from_typedef_Card (c_call), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_validate (SCM g_ai, SCM g_validation_game)
{
/* Declaration of the types for input parameters */
  TarotAi *c_ai;
  TarotGame *c_validation_game;
/* Declaration of the type for the return value */
  double c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_ai = scm_to_pointer (g_ai);
  c_validation_game = scm_to_pointer (g_validation_game);
/* Calling the function */
  c_ret = (double) tarot_ai_validate (c_ai, c_validation_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_double (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_ai_alloc (SCM g_user_data, SCM g_eval, SCM g_learn,
			    SCM g_dup, SCM g_destruct)
{
/* Declaration of the types for input parameters */
  void *c_user_data;
  void *c_eval;
  void *c_learn;
  void *c_dup;
  void *c_destruct;
/* Declaration of the type for the return value */
  TarotAi *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_user_data = scm_to_pointer (g_user_data);
  c_eval = scm_to_pointer (g_eval);
  c_learn = scm_to_pointer (g_learn);
  c_dup = scm_to_pointer (g_dup);
  c_destruct = scm_to_pointer (g_destruct);
/* Calling the function */
  c_ret =
    (TarotAi *) tarot_ai_alloc (c_user_data, c_eval, c_learn, c_dup,
				c_destruct);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Ai (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_bid_check (SCM g_base, SCM g_new_bid)
{
/* Declaration of the types for input parameters */
  TarotBid c_base;
  TarotBid c_new_bid;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */
  int c_superior = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_base = scm_to_enum_Bid (g_base);
  c_new_bid = scm_to_enum_Bid (g_new_bid);
/* Calling the function */
  c_ret = (int) tarot_bid_check (c_base, c_new_bid, &c_superior);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_superior), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_bid_discard_allowed (SCM g_bid)
{
/* Declaration of the types for input parameters */
  TarotBid c_bid;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_bid = scm_to_enum_Bid (g_bid);
/* Calling the function */
  c_ret = (int) tarot_bid_discard_allowed (c_bid);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_bid_discard_counted (SCM g_bid)
{
/* Declaration of the types for input parameters */
  TarotBid c_bid;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_bid = scm_to_enum_Bid (g_bid);
/* Calling the function */
  c_ret = (int) tarot_bid_discard_counted (c_bid);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_bid_multiplier (SCM g_bid)
{
/* Declaration of the types for input parameters */
  TarotBid c_bid;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_bid = scm_to_enum_Bid (g_bid);
/* Calling the function */
  c_ret = (int) tarot_bid_multiplier (c_bid);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_int (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_alloc ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  TarotCounter *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (TarotCounter *) tarot_counter_alloc ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Counter (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_and_game_impute (SCM g_counter, SCM g_game,
					   SCM g_seed)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_counter;
  TarotGame *c_game;
  size_t c_seed_size;
  char *c_seed;
/* Declaration of the type for the return value */
  TarotImputationError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_counter = scm_to_pointer (g_counter);
  c_game = scm_to_pointer (g_game);
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
/* Calling the function */
  c_ret =
    (TarotImputationError) tarot_counter_and_game_impute (c_counter, c_game,
							  c_seed_size,
							  c_seed);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_ImputationError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_and_game_impute_likely (SCM g_counter, SCM g_game,
						  SCM g_seed_size, SCM g_seed)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_counter;
  TarotGame *c_game;
  size_t c_seed_size;
  void *c_seed;
/* Declaration of the type for the return value */
  TarotImputationError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_counter = scm_to_pointer (g_counter);
  c_game = scm_to_pointer (g_game);
  c_seed_size = scm_to_size_t (g_seed_size);
  c_seed = scm_to_pointer (g_seed);
/* Calling the function */
  c_ret =
    (TarotImputationError) tarot_counter_and_game_impute_likely (c_counter,
								 c_game,
								 c_seed_size,
								 c_seed);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_ImputationError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_copy (SCM g_dest, SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_dest;
  TarotCounter *c_source;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_dest = scm_to_pointer (g_dest);
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  tarot_counter_copy (c_dest, c_source);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_dup (SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_source;
/* Declaration of the type for the return value */
  TarotCounter *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotCounter *) tarot_counter_dup (c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Counter (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_load_from_game (SCM g_counter, SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_counter;
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_counter = scm_to_pointer (g_counter);
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_counter_load_from_game (c_counter, c_game);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_may_be_in_doscard (SCM g_counter, SCM g_c)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_counter;
  TarotCard c_c;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_counter = scm_to_pointer (g_counter);
  c_c = scm_to_typedef_Card (g_c);
/* Calling the function */
  c_ret = (int) tarot_counter_may_be_in_doscard (c_counter, c_c);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_may_own (SCM g_counter, SCM g_who, SCM g_card)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_counter;
  size_t c_n_query;
  TarotPlayer *c_who;
  TarotCard c_card;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_counter = scm_to_pointer (g_counter);
  c_who = scm_to_array_typedef_Player (&c_n_query, g_who);
  c_card = scm_to_typedef_Card (g_card);
/* Calling the function */
  c_ret = (int) tarot_counter_may_own (c_counter, c_n_query, c_who, c_card);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_n_cards_doscard (SCM g_counter)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_counter;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_counter = scm_to_pointer (g_counter);
/* Calling the function */
  c_ret = (size_t) tarot_counter_n_cards_doscard (c_counter);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_n_cards_remaining (SCM g_counter, SCM g_who)
{
/* Declaration of the types for input parameters */
  TarotCounter *c_counter;
  TarotPlayer c_who;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_counter = scm_to_pointer (g_counter);
  c_who = scm_to_typedef_Player (g_who);
/* Calling the function */
  c_ret = (size_t) tarot_counter_n_cards_remaining (c_counter, c_who);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_counter_construct (SCM g_mem_out)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_counter_construct (c_max_mem, c_mem_out, &c_alignment);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_alloc ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  TarotGame *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (TarotGame *) tarot_game_alloc ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Game (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_add_event (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_add_event (c_game, c_event);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_assign_missing_card (SCM g_game, SCM g_card,
					    SCM g_owner)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotCard c_card;
  TarotPlayer c_owner;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_card = scm_to_typedef_Card (g_card);
  c_owner = scm_to_typedef_Player (g_owner);
/* Calling the function */
  c_ret = (int) tarot_game_assign_missing_card (c_game, c_card, c_owner);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_int (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_can_autoreveal (SCM g_game, SCM g_start, SCM g_dog_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  TarotCard *c_dog_out;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_dog = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_dog_out = scm_to_array_typedef_Card (&c_max, g_dog_out);
/* Calling the function */
  c_ret =
    (int) tarot_game_can_autoreveal (c_game, &c_n_dog, c_start, c_max,
				     c_dog_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_dog), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_can_autoreveal_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (int) tarot_game_can_autoreveal_alloc (c_game, &c_n, &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_check_card (SCM g_game, SCM g_card)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotCard c_card;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */
  int c_cannot_follow = 0;
  TarotSuit c_lead_suit = TAROT_HEARTS;
  int c_cannot_overtrump = 0;
  TarotNumber c_max_trump = 0;
  int c_cannot_undertrump = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_card = scm_to_typedef_Card (g_card);
/* Calling the function */
  c_ret =
    (int) tarot_game_check_card (c_game, c_card, &c_cannot_follow,
				 &c_lead_suit, &c_cannot_overtrump,
				 &c_max_trump, &c_cannot_undertrump);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_cannot_follow), g_ret);
  g_ret = scm_cons (scm_from_enum_Suit (c_lead_suit), g_ret);
  g_ret = scm_cons (scm_from_bool (c_cannot_overtrump), g_ret);
  g_ret = scm_cons (scm_from_typedef_Number (c_max_trump), g_ret);
  g_ret = scm_cons (scm_from_bool (c_cannot_undertrump), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_check_event (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (int) tarot_game_check_event (c_game, c_event);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_copy (SCM g_dest, SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotGame *c_dest;
  TarotGame *c_source;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_dest = scm_to_pointer (g_dest);
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  tarot_game_copy (c_dest, c_source);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_copy_as (SCM g_dest, SCM g_source, SCM g_who)
{
/* Declaration of the types for input parameters */
  TarotGame *c_dest;
  TarotGame *c_source;
  TarotPlayer c_who;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_dest = scm_to_pointer (g_dest);
  c_source = scm_to_pointer (g_source);
  c_who = scm_to_typedef_Player (g_who);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_copy_as (c_dest, c_source, c_who);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_dup (SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotGame *c_source;
/* Declaration of the type for the return value */
  TarotGame *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotGame *) tarot_game_dup (c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Game (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_duplicate_set_call (SCM g_game, SCM g_call)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotCard c_call;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_call = scm_to_typedef_Card (g_call);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_duplicate_set_call (c_game, c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_duplicate_set_deal (SCM g_game, SCM g_owners)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_n_owners;
  TarotPlayer *c_owners;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_owners = scm_to_array_typedef_Player (&c_n_owners, g_owners);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_duplicate_set_deal (c_game, c_n_owners,
						    c_owners);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_duplicate_set_taker (SCM g_game, SCM g_taker)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_taker;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_taker = scm_to_typedef_Player (g_taker);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_duplicate_set_taker (c_game, c_taker);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_bids (SCM g_game, SCM g_start, SCM g_bids_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_start;
  size_t c_max;
  TarotBid *c_bids_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_typedef_Player (g_start);
  c_bids_out = scm_to_array_enum_Bid (&c_max, g_bids_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_bids (c_game, &c_n, c_start, c_max,
					  c_bids_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_bids_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  TarotBid *c_bids = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_bids_alloc (c_game, &c_n, &c_bids);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_enum_Bid (c_n, c_bids), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_call (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotCard c_card = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_call (c_game, &c_card);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Card (c_card), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_cards (SCM g_game, SCM g_who, SCM g_start,
				  SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_who;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_who = scm_to_typedef_Player (g_who);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_cards (c_game, c_who, &c_n, c_start,
					   c_max, c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_cards_alloc (SCM g_game, SCM g_who)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_who;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_who = scm_to_typedef_Player (g_who);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_cards_alloc (c_game, c_who, &c_n,
						 &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_current_trick (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_current = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_current_trick (c_game, &c_current);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_current), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_deal_all (SCM g_game, SCM g_start,
				     SCM g_owners_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  TarotPlayer *c_owners_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_owners_out = scm_to_array_typedef_Player (&c_max, g_owners_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_deal_all (c_game, &c_n, c_start, c_max,
					      c_owners_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_deal_all_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  TarotPlayer *c_owners = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_deal_all_alloc (c_game, &c_n, &c_owners);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Player (c_n, c_owners), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_deal_of (SCM g_game, SCM g_who, SCM g_start,
				    SCM g_deal_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_who;
  size_t c_start;
  size_t c_max;
  TarotCard *c_deal_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_who = scm_to_typedef_Player (g_who);
  c_start = scm_to_size_t (g_start);
  c_deal_out = scm_to_array_typedef_Card (&c_max, g_deal_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_deal_of (c_game, c_who, &c_n, c_start,
					     c_max, c_deal_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_deal_of_alloc (SCM g_game, SCM g_who)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_who;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_who = scm_to_typedef_Player (g_who);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_deal_of_alloc (c_game, c_who, &c_n,
						   &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_declarant (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_declarant = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_declarant (c_game, &c_declarant);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_declarant), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_declarations (SCM g_game, SCM g_start,
					 SCM g_decls_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_start;
  size_t c_max;
  int *c_decls_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_typedef_Player (g_start);
  c_decls_out = scm_to_array_bool (&c_max, g_decls_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_declarations (c_game, &c_n, c_start,
						  c_max, c_decls_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_declarations_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  int *c_declarations = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_declarations_alloc (c_game, &c_n,
							&c_declarations);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_bool (c_n, c_declarations), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_dog (SCM g_game, SCM g_start, SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_dog (c_game, &c_n, c_start, c_max,
					 c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_dog_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_dog_alloc (c_game, &c_n_cards, &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_cards, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_full_discard (SCM g_game, SCM g_start,
					 SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_full_discard (c_game, &c_n, c_start,
						  c_max, c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_full_discard_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_full_discard_alloc (c_game, &c_n,
							&c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_handful (SCM g_game, SCM g_p, SCM g_start,
				    SCM g_cards)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_p;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  int c_size = 0;
  size_t c_n_cards = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_p = scm_to_typedef_Player (g_p);
  c_start = scm_to_size_t (g_start);
  c_cards = scm_to_array_typedef_Card (&c_max, g_cards);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_handful (c_game, c_p, &c_size, &c_n_cards,
					     c_start, c_max, c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_int (c_size), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_handful_alloc (SCM g_game, SCM g_p)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotPlayer c_p;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  int c_size = 0;
  size_t c_n_cards = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_p = scm_to_typedef_Player (g_p);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_handful_alloc (c_game, c_p, &c_size,
						   &c_n_cards, &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_int (c_size), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_cards, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_bid (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  TarotBid c_mini = TAROT_PASS;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_bid (c_game, &c_player, &c_mini);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_enum_Bid (c_mini), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_call (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  TarotNumber c_mini = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_call (c_game, &c_player, &c_mini);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_typedef_Number (c_mini), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_card (SCM g_game, SCM g_start,
				      SCM g_playable_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  TarotCard *c_playable_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_playable_out = scm_to_array_typedef_Card (&c_max, g_playable_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_card (c_game, &c_player, &c_n,
					       c_start, c_max,
					       c_playable_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_card_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  size_t c_n_playable = 0;
  TarotCard *c_playable = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_card_alloc (c_game, &c_player,
						     &c_n_playable,
						     &c_playable);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_playable), g_ret);
  g_ret =
    scm_cons (scm_from_array_typedef_Card (c_n_playable, c_playable), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_decl (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  int c_allowed = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_decl (c_game, &c_player, &c_allowed);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_bool (c_allowed), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_discard (SCM g_game, SCM g_start_prio,
					 SCM g_prio_out,
					 SCM g_start_additional,
					 SCM g_additional_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start_prio;
  size_t c_max_prio;
  TarotCard *c_prio_out;
  size_t c_start_additional;
  size_t c_max_additional;
  TarotCard *c_additional_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  size_t c_n_cards = 0;
  size_t c_n_prio = 0;
  size_t c_n_additional = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start_prio = scm_to_size_t (g_start_prio);
  c_prio_out = scm_to_array_typedef_Card (&c_max_prio, g_prio_out);
  c_start_additional = scm_to_size_t (g_start_additional);
  c_additional_out =
    scm_to_array_typedef_Card (&c_max_additional, g_additional_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_discard (c_game, &c_player,
						  &c_n_cards, &c_n_prio,
						  c_start_prio, c_max_prio,
						  c_prio_out, &c_n_additional,
						  c_start_additional,
						  c_max_additional,
						  c_additional_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_prio), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_additional), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_discard_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  size_t c_n_cards = 0;
  size_t c_n_prio = 0;
  TarotCard *c_prio = NULL;
  size_t c_n_additional = 0;
  TarotCard *c_additional = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_discard_alloc (c_game, &c_player,
							&c_n_cards, &c_n_prio,
							&c_prio,
							&c_n_additional,
							&c_additional);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_prio), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_prio, c_prio), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_additional), g_ret);
  g_ret =
    scm_cons (scm_from_array_typedef_Card (c_n_additional, c_additional),
	      g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_handful (SCM g_game, SCM g_start_prio,
					 SCM g_prio_out,
					 SCM g_start_additional,
					 SCM g_additional_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start_prio;
  size_t c_max_prio;
  TarotCard *c_prio_out;
  size_t c_start_additional;
  size_t c_max_additional;
  TarotCard *c_additional_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  size_t c_n_simple = 0;
  size_t c_n_double = 0;
  size_t c_n_triple = 0;
  size_t c_n_prio = 0;
  size_t c_n_additional = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start_prio = scm_to_size_t (g_start_prio);
  c_prio_out = scm_to_array_typedef_Card (&c_max_prio, g_prio_out);
  c_start_additional = scm_to_size_t (g_start_additional);
  c_additional_out =
    scm_to_array_typedef_Card (&c_max_additional, g_additional_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_handful (c_game, &c_player,
						  &c_n_simple, &c_n_double,
						  &c_n_triple, &c_n_prio,
						  c_start_prio, c_max_prio,
						  c_prio_out, &c_n_additional,
						  c_start_additional,
						  c_max_additional,
						  c_additional_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_simple), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_double), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_triple), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_prio), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_additional), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_hint_handful_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_player = 0;
  size_t c_n_simple = 0;
  size_t c_n_double = 0;
  size_t c_n_triple = 0;
  size_t c_n_prio = 0;
  TarotCard *c_prio = NULL;
  size_t c_n_additional = 0;
  TarotCard *c_additional = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_hint_handful_alloc (c_game, &c_player,
							&c_n_simple,
							&c_n_double,
							&c_n_triple,
							&c_n_prio, &c_prio,
							&c_n_additional,
							&c_additional);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_player), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_simple), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_double), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_triple), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_prio), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_prio, c_prio), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_additional), g_ret);
  g_ret =
    scm_cons (scm_from_array_typedef_Card (c_n_additional, c_additional),
	      g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_lead_suit (SCM g_game, SCM g_i_trick)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_i_trick;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotSuit c_lead_suit = TAROT_HEARTS;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_i_trick = scm_to_size_t (g_i_trick);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_lead_suit (c_game, c_i_trick,
					       &c_lead_suit);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_enum_Suit (c_lead_suit), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_main_player (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_main = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_main_player (c_game, &c_main);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_main), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_max_trump (SCM g_game, SCM g_i_trick)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_i_trick;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotNumber c_max_trump = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_i_trick = scm_to_size_t (g_i_trick);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_max_trump (c_game, c_i_trick,
					       &c_max_trump);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Number (c_max_trump), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_next (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_next = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_next (c_game, &c_next);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_next), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_partner (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_partner = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_partner (c_game, &c_partner);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_partner), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_points_in_trick (SCM g_game, SCM g_i_trick)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_i_trick;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  unsigned int c_halfpoints = 0;
  unsigned int c_oudlers = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_i_trick = scm_to_size_t (g_i_trick);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_points_in_trick (c_game, c_i_trick,
						     &c_halfpoints,
						     &c_oudlers);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_uint (c_halfpoints), g_ret);
  g_ret = scm_cons (scm_from_uint (c_oudlers), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_public_discard (SCM g_game, SCM g_start,
					   SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_public_discard (c_game, &c_n, c_start,
						    c_max, c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_public_discard_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_public_discard_alloc (c_game, &c_n,
							  &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_scores (SCM g_game, SCM g_start, SCM g_scores_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  int *c_scores_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_scores_out = scm_to_array_int (&c_max, g_scores_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_scores (c_game, &c_n, c_start, c_max,
					    c_scores_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_scores_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n = 0;
  int *c_scores = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_scores_alloc (c_game, &c_n, &c_scores);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_int (c_n, c_scores), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_taker (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_taker = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_get_taker (c_game, &c_taker);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_taker), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_trick_cards (SCM g_game, SCM g_i_trick,
					SCM g_start, SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_i_trick;
  size_t c_start;
  size_t c_max;
  TarotGameCardAnalysis *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_i_trick = scm_to_size_t (g_i_trick);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_struct_GameCardAnalysis (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_trick_cards (c_game, c_i_trick,
						 &c_n_cards, c_start, c_max,
						 c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_trick_cards_alloc (SCM g_game, SCM g_i_trick)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_i_trick;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
  TarotGameCardAnalysis *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_i_trick = scm_to_size_t (g_i_trick);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_trick_cards_alloc (c_game, c_i_trick,
						       &c_n_cards, &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret =
    scm_cons (scm_from_array_struct_GameCardAnalysis (c_n_cards, c_cards),
	      g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_trick_leader (SCM g_game, SCM g_i_trick)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_i_trick;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_leader = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_i_trick = scm_to_size_t (g_i_trick);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_trick_leader (c_game, c_i_trick,
						  &c_leader);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_leader), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_get_trick_taker (SCM g_game, SCM g_i_trick)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_i_trick;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_taker = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_i_trick = scm_to_size_t (g_i_trick);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_game_get_trick_taker (c_game, c_i_trick, &c_taker);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_taker), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_iterator (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotGameIterator *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotGameIterator *) tarot_game_iterator (c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameIterator (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_load_from_xml (SCM g_game, SCM g_input)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  char *c_input;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_input = scm_to_narrow_string (g_input);
/* Calling the function */
  c_ret = (TarotGameError) tarot_game_load_from_xml (c_game, c_input);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_n_players (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (size_t) tarot_game_n_players (c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_n_tricks (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (size_t) tarot_game_n_tricks (c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_save_to_xml (SCM g_game, SCM g_start, SCM g_dest_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  char *c_dest_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_dest_out = scm_to_array_char (&c_max, g_dest_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_save_to_xml (c_game, c_start, c_max, c_dest_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_save_to_xml_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (char *) tarot_game_save_to_xml_alloc (c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
  free (c_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_step (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotStep c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotStep) tarot_game_step (c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_Step (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_with_call (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (int) tarot_game_with_call (c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_bool (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_construct (SCM g_mem_out)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
/* Calling the function */
  c_ret = (size_t) tarot_game_construct (c_max_mem, c_mem_out, &c_alignment);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_bid (SCM g_bid)
{
/* Declaration of the types for input parameters */
  TarotBid c_bid;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_bid = scm_to_enum_Bid (g_bid);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_game_event_alloc_bid (c_bid);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_call (SCM g_call)
{
/* Declaration of the types for input parameters */
  TarotCard c_call;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_call = scm_to_typedef_Card (g_call);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_game_event_alloc_call (c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_card (SCM g_call)
{
/* Declaration of the types for input parameters */
  TarotCard c_call;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_call = scm_to_typedef_Card (g_call);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_game_event_alloc_card (c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_deal (SCM g_myself, SCM g_cards)
{
/* Declaration of the types for input parameters */
  TarotPlayer c_myself;
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_myself = scm_to_typedef_Player (g_myself);
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret =
    (TarotGameEvent *) tarot_game_event_alloc_deal (c_myself, c_n_cards,
						    c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_deal_all (SCM g_owners)
{
/* Declaration of the types for input parameters */
  size_t c_n_owners;
  TarotPlayer *c_owners;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_owners = scm_to_array_typedef_Player (&c_n_owners, g_owners);
/* Calling the function */
  c_ret =
    (TarotGameEvent *) tarot_game_event_alloc_deal_all (c_n_owners, c_owners);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_deal_all_random (SCM g_n_players,
						    SCM g_seed)
{
/* Declaration of the types for input parameters */
  size_t c_n_players;
  size_t c_seed_size;
  char *c_seed;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_n_players = scm_to_size_t (g_n_players);
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
/* Calling the function */
  c_ret =
    (TarotGameEvent *) tarot_game_event_alloc_deal_all_random (c_n_players,
							       c_seed_size,
							       c_seed);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_decl (SCM g_decl)
{
/* Declaration of the types for input parameters */
  int c_decl;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_decl = scm_to_bool (g_decl);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_game_event_alloc_decl (c_decl);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_discard (SCM g_cards)
{
/* Declaration of the types for input parameters */
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret =
    (TarotGameEvent *) tarot_game_event_alloc_discard (c_n_cards, c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_dog (SCM g_cards)
{
/* Declaration of the types for input parameters */
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_game_event_alloc_dog (c_n_cards, c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_handful (SCM g_cards)
{
/* Declaration of the types for input parameters */
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret =
    (TarotGameEvent *) tarot_game_event_alloc_handful (c_n_cards, c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_alloc_setup (SCM g_n_players, SCM g_with_call)
{
/* Declaration of the types for input parameters */
  size_t c_n_players;
  int c_with_call;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_n_players = scm_to_size_t (g_n_players);
  c_with_call = scm_to_bool (g_with_call);
/* Calling the function */
  c_ret =
    (TarotGameEvent *) tarot_game_event_alloc_setup (c_n_players,
						     c_with_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_dup (SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_source;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_game_event_dup (c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_bid (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  TarotBid c_bid = TAROT_PASS;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (TarotGameEventError) tarot_game_event_get_bid (c_event, &c_bid);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_enum_Bid (c_bid), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_call (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  TarotCard c_call = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (TarotGameEventError) tarot_game_event_get_call (c_event, &c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Card (c_call), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_card (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  TarotCard c_card = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (TarotGameEventError) tarot_game_event_get_card (c_event, &c_card);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Card (c_card), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_deal (SCM g_event, SCM g_start,
				       SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_myself = 0;
  size_t c_n_cards = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_deal (c_event, &c_myself,
						     &c_n_cards, c_start,
						     c_max, c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_myself), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_deal_all (SCM g_event, SCM g_start,
					   SCM g_owners_out)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
  size_t c_start;
  size_t c_max;
  TarotPlayer *c_owners_out;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_owners = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
  c_start = scm_to_size_t (g_start);
  c_owners_out = scm_to_array_typedef_Player (&c_max, g_owners_out);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_deal_all (c_event, &c_n_owners,
							 c_start, c_max,
							 c_owners_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_owners), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_deal_all_alloc (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_owners = 0;
  TarotPlayer *c_owners = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_deal_all_alloc (c_event,
							       &c_n_owners,
							       &c_owners);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_owners), g_ret);
  g_ret =
    scm_cons (scm_from_array_typedef_Player (c_n_owners, c_owners), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_deal_alloc (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  TarotPlayer c_whom = 0;
  size_t c_n_cards = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_deal_alloc (c_event, &c_whom,
							   &c_n_cards,
							   &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Player (c_whom), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_cards, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_decl (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  int c_decl = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (TarotGameEventError) tarot_game_event_get_decl (c_event, &c_decl);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_decl), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_discard (SCM g_event, SCM g_start,
					  SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_discard (c_event, &c_n_cards,
							c_start, c_max,
							c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_discard_alloc (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_discard_alloc (c_event,
							      &c_n_cards,
							      &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_cards, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_dog (SCM g_event, SCM g_start,
				      SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_dog (c_event, &c_n_cards,
						    c_start, c_max,
						    c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_dog_alloc (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_dog_alloc (c_event, &c_n_cards,
							  &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_cards, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_handful (SCM g_event, SCM g_start,
					  SCM g_cards_out)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
  size_t c_start;
  size_t c_max;
  TarotCard *c_cards_out;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
  c_start = scm_to_size_t (g_start);
  c_cards_out = scm_to_array_typedef_Card (&c_max, g_cards_out);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_handful (c_event, &c_n_cards,
							c_start, c_max,
							c_cards_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_handful_alloc (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_cards = 0;
  TarotCard *c_cards = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_handful_alloc (c_event,
							      &c_n_cards,
							      &c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_cards), g_ret);
  g_ret = scm_cons (scm_from_array_typedef_Card (c_n_cards, c_cards), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_get_setup (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventError c_ret;
/* Declaration of the types for output parameters */
  size_t c_n_players = 0;
  int c_with_call = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret =
    (TarotGameEventError) tarot_game_event_get_setup (c_event, &c_n_players,
						      &c_with_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventError (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_players), g_ret);
  g_ret = scm_cons (scm_from_bool (c_with_call), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_type (SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameEventT c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (TarotGameEventT) tarot_game_event_type (c_event);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameEventT (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_bid (SCM g_mem_out, SCM g_bid)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  TarotBid c_bid;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_bid = scm_to_enum_Bid (g_bid);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_bid (c_max_mem, c_mem_out,
					     &c_alignment, c_bid);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_call (SCM g_mem_out, SCM g_call)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  TarotCard c_call;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_call = scm_to_typedef_Card (g_call);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_call (c_max_mem, c_mem_out,
					      &c_alignment, c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_card (SCM g_mem_out, SCM g_card)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  TarotCard c_card;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_card = scm_to_typedef_Card (g_card);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_card (c_max_mem, c_mem_out,
					      &c_alignment, c_card);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_copy (SCM g_mem_out, SCM g_source)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  TarotGameEvent *c_source;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_copy (c_max_mem, c_mem_out,
					      &c_alignment, c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_deal (SCM g_mem_out, SCM g_myself,
					     SCM g_cards)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  TarotPlayer c_myself;
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_myself = scm_to_typedef_Player (g_myself);
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_deal (c_max_mem, c_mem_out,
					      &c_alignment, c_myself,
					      c_n_cards, c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_deal_all (SCM g_mem_out, SCM g_owners)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  size_t c_n_owners;
  TarotPlayer *c_owners;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_owners = scm_to_array_typedef_Player (&c_n_owners, g_owners);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_deal_all (c_max_mem, c_mem_out,
						  &c_alignment, c_n_owners,
						  c_owners);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_deal_all_random (SCM g_mem_out,
							SCM g_n_players,
							SCM g_seed)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  size_t c_n_players;
  size_t c_seed_size;
  char *c_seed;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_n_players = scm_to_size_t (g_n_players);
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_deal_all_random (c_max_mem, c_mem_out,
							 &c_alignment,
							 c_n_players,
							 c_seed_size, c_seed);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_decl (SCM g_mem_out, SCM g_slam)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  int c_slam;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_slam = scm_to_bool (g_slam);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_decl (c_max_mem, c_mem_out,
					      &c_alignment, c_slam);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_discard (SCM g_mem_out, SCM g_cards)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_discard (c_max_mem, c_mem_out,
						 &c_alignment, c_n_cards,
						 c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_dog (SCM g_mem_out, SCM g_cards)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_dog (c_max_mem, c_mem_out,
					     &c_alignment, c_n_cards,
					     c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_handful (SCM g_mem_out, SCM g_cards)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  size_t c_n_cards;
  TarotCard *c_cards;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_cards = scm_to_array_typedef_Card (&c_n_cards, g_cards);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_handful (c_max_mem, c_mem_out,
						 &c_alignment, c_n_cards,
						 c_cards);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_event_construct_setup (SCM g_mem_out, SCM g_n_players,
					      SCM g_with_call)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  size_t c_n_players;
  int c_with_call;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_n_players = scm_to_size_t (g_n_players);
  c_with_call = scm_to_bool (g_with_call);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_event_construct_setup (c_max_mem, c_mem_out,
					       &c_alignment, c_n_players,
					       c_with_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_iterator_dup (SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotGameIterator *c_source;
/* Declaration of the type for the return value */
  TarotGameIterator *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotGameIterator *) tarot_game_iterator_dup (c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameIterator (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_iterator_next_value (SCM g_iterator)
{
/* Declaration of the types for input parameters */
  TarotGameIterator *c_iterator;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_iterator = scm_to_pointer (g_iterator);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_game_iterator_next_value (c_iterator);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 0), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_game_iterator_construct (SCM g_mem_out, SCM g_game)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  TarotGame *c_game;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret =
    (size_t) tarot_game_iterator_construct (c_max_mem, c_mem_out,
					    &c_alignment, c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_alloc (SCM g_max_mem)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
/* Declaration of the type for the return value */
  TarotMcts *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_max_mem = scm_to_size_t (g_max_mem);
/* Calling the function */
  c_ret = (TarotMcts *) tarot_mcts_alloc (c_max_mem);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Mcts (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_copy (SCM g_dest, SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotMcts *c_dest;
  TarotMcts *c_source;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_dest = scm_to_pointer (g_dest);
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  tarot_mcts_copy (c_dest, c_source);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_get_best (SCM g_mcts)
{
/* Declaration of the types for input parameters */
  TarotMcts *c_mcts;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mcts = scm_to_pointer (g_mcts);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_mcts_get_best (c_mcts);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 0), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_run (SCM g_mcts, SCM g_n_iterations)
{
/* Declaration of the types for input parameters */
  TarotMcts *c_mcts;
  size_t c_n_iterations;
/* Declaration of the type for the return value */
  TarotMctsError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mcts = scm_to_pointer (g_mcts);
  c_n_iterations = scm_to_size_t (g_n_iterations);
/* Calling the function */
  c_ret = (TarotMctsError) tarot_mcts_run (c_mcts, c_n_iterations);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_MctsError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_seed (SCM g_mcts, SCM g_seed)
{
/* Declaration of the types for input parameters */
  TarotMcts *c_mcts;
  size_t c_seed_size;
  char *c_seed;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mcts = scm_to_pointer (g_mcts);
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
/* Calling the function */
  tarot_mcts_seed (c_mcts, c_seed_size, c_seed);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_set_base (SCM g_mcts, SCM g_base)
{
/* Declaration of the types for input parameters */
  TarotMcts *c_mcts;
  TarotGame *c_base;
/* Declaration of the type for the return value */
  TarotMctsError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mcts = scm_to_pointer (g_mcts);
  c_base = scm_to_pointer (g_base);
/* Calling the function */
  c_ret = (TarotMctsError) tarot_mcts_set_base (c_mcts, c_base);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_MctsError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_construct (SCM g_mem_out, SCM g_max_pool)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  size_t c_max_pool;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_max_pool = scm_to_size_t (g_max_pool);
/* Calling the function */
  c_ret =
    (size_t) tarot_mcts_construct (c_max_mem, c_mem_out, &c_alignment,
				   c_max_pool);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_mcts_dup (SCM g_new_max_mem, SCM g_source)
{
/* Declaration of the types for input parameters */
  size_t c_new_max_mem;
  TarotMcts *c_source;
/* Declaration of the type for the return value */
  TarotMcts *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_new_max_mem = scm_to_size_t (g_new_max_mem);
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotMcts *) tarot_mcts_dup (c_new_max_mem, c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Mcts (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_static_default ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  TarotPerceptron *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (TarotPerceptron *) tarot_perceptron_static_default ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Perceptron (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_dup (SCM g_perceptron)
{
/* Declaration of the types for input parameters */
  TarotPerceptron *c_perceptron;
/* Declaration of the type for the return value */
  TarotPerceptron *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_perceptron = scm_to_pointer (g_perceptron);
/* Calling the function */
  c_ret = (TarotPerceptron *) tarot_perceptron_dup (c_perceptron);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Perceptron (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_eval (SCM g_perceptron, SCM g_base,
				   SCM g_candidates, SCM g_start,
				   SCM g_scores)
{
/* Declaration of the types for input parameters */
  TarotPerceptron *c_perceptron;
  TarotGame *c_base;
  size_t c_n_candidates;
  TarotGameEvent **c_candidates;
  size_t c_start;
  size_t c_max;
  double *c_scores;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_perceptron = scm_to_pointer (g_perceptron);
  c_base = scm_to_pointer (g_base);
  c_candidates = scm_to_array_pointer (&c_n_candidates, g_candidates);
  c_start = scm_to_size_t (g_start);
  c_scores = scm_to_array_double (&c_max, g_scores);
/* Calling the function */
  tarot_perceptron_eval (c_perceptron, c_base, c_n_candidates, c_candidates,
			 c_start, c_max, c_scores);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_learn (SCM g_perceptron, SCM g_base, SCM g_event,
				    SCM g_final_score)
{
/* Declaration of the types for input parameters */
  TarotPerceptron *c_perceptron;
  TarotGame *c_base;
  TarotGameEvent *c_event;
  double c_final_score;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_perceptron = scm_to_pointer (g_perceptron);
  c_base = scm_to_pointer (g_base);
  c_event = scm_to_pointer (g_event);
  c_final_score = scm_to_double (g_final_score);
/* Calling the function */
  tarot_perceptron_learn (c_perceptron, c_base, c_event, c_final_score);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_load (SCM g_perceptron, SCM g_start,
				   SCM g_parameters)
{
/* Declaration of the types for input parameters */
  TarotPerceptron *c_perceptron;
  size_t c_start;
  size_t c_n_weights;
  double *c_parameters;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_perceptron = scm_to_pointer (g_perceptron);
  c_start = scm_to_size_t (g_start);
  c_parameters = scm_to_array_double (&c_n_weights, g_parameters);
/* Calling the function */
  tarot_perceptron_load (c_perceptron, c_start, c_n_weights, c_parameters);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_save (SCM g_perceptron, SCM g_start,
				   SCM g_parameters)
{
/* Declaration of the types for input parameters */
  TarotPerceptron *c_perceptron;
  size_t c_start;
  size_t c_max;
  double *c_parameters;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_perceptron = scm_to_pointer (g_perceptron);
  c_start = scm_to_size_t (g_start);
  c_parameters = scm_to_array_double (&c_max, g_parameters);
/* Calling the function */
  c_ret =
    (size_t) tarot_perceptron_save (c_perceptron, c_start, c_max,
				    c_parameters);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_save_alloc (SCM g_perceptron)
{
/* Declaration of the types for input parameters */
  TarotPerceptron *c_perceptron;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n = 0;
  double *c_data = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_perceptron = scm_to_pointer (g_perceptron);
/* Calling the function */
  tarot_perceptron_save_alloc (c_perceptron, &c_n, &c_data);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
  g_ret = scm_cons (scm_from_array_double (c_n, c_data), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_set_learning_rate (SCM g_perceptron,
						SCM g_learning_rate)
{
/* Declaration of the types for input parameters */
  TarotPerceptron *c_perceptron;
  double c_learning_rate;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_perceptron = scm_to_pointer (g_perceptron);
  c_learning_rate = scm_to_double (g_learning_rate);
/* Calling the function */
  tarot_perceptron_set_learning_rate (c_perceptron, c_learning_rate);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_perceptron_alloc (SCM g_hidden_sizes, SCM g_learning_rate)
{
/* Declaration of the types for input parameters */
  size_t c_n_hidden_layers;
  size_t *c_hidden_sizes;
  double c_learning_rate;
/* Declaration of the type for the return value */
  TarotPerceptron *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_hidden_sizes = scm_to_array_size_t (&c_n_hidden_layers, g_hidden_sizes);
  c_learning_rate = scm_to_double (g_learning_rate);
/* Calling the function */
  c_ret =
    (TarotPerceptron *) tarot_perceptron_alloc (c_n_hidden_layers,
						c_hidden_sizes,
						c_learning_rate);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Perceptron (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_predictor_alloc ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  TarotPredictor *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (TarotPredictor *) tarot_predictor_alloc ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Predictor (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_predictor_best (SCM g_predictor)
{
/* Declaration of the types for input parameters */
  TarotPredictor *c_predictor;
/* Declaration of the type for the return value */
  TarotGameEvent *c_ret;
/* Declaration of the types for output parameters */
  double c_score = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_predictor = scm_to_pointer (g_predictor);
/* Calling the function */
  c_ret = (TarotGameEvent *) tarot_predictor_best (c_predictor, &c_score);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_GameEvent (c_ret, 0), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_double (c_score), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_predictor_copy (SCM g_predictor, SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotPredictor *c_predictor;
  TarotPredictor *c_source;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_predictor = scm_to_pointer (g_predictor);
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  tarot_predictor_copy (c_predictor, c_source);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_predictor_dup (SCM g_predictor)
{
/* Declaration of the types for input parameters */
  TarotPredictor *c_predictor;
/* Declaration of the type for the return value */
  TarotPredictor *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_predictor = scm_to_pointer (g_predictor);
/* Calling the function */
  c_ret = (TarotPredictor *) tarot_predictor_dup (c_predictor);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Predictor (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_predictor_eval (SCM g_predictor, SCM g_candidates,
				  SCM g_start, SCM g_score_out)
{
/* Declaration of the types for input parameters */
  TarotPredictor *c_predictor;
  size_t c_n_candidates;
  TarotGameEvent **c_candidates;
  size_t c_start;
  size_t c_max;
  double *c_score_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_predictor = scm_to_pointer (g_predictor);
  c_candidates = scm_to_array_pointer (&c_n_candidates, g_candidates);
  c_start = scm_to_size_t (g_start);
  c_score_out = scm_to_array_double (&c_max, g_score_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_predictor_eval (c_predictor, c_n_candidates, c_candidates,
				   c_start, c_max, c_score_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_predictor_set_game (SCM g_predictor, SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotPredictor *c_predictor;
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_predictor = scm_to_pointer (g_predictor);
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_predictor_set_game (c_predictor, c_game);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_predictor_construct (SCM g_mem_out)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_predictor_construct (c_max_mem, c_mem_out, &c_alignment);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_alloc ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  TarotSolo *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (TarotSolo *) tarot_solo_alloc ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Solo (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_alloc_fuzzy (SCM g_fuzziness, SCM g_seed, SCM g_ai)
{
/* Declaration of the types for input parameters */
  double c_fuzziness;
  size_t c_seed_size;
  char *c_seed;
  TarotAi *c_ai;
/* Declaration of the type for the return value */
  TarotSolo *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_fuzziness = scm_to_double (g_fuzziness);
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
  c_ai = scm_to_pointer (g_ai);
/* Calling the function */
  c_ret =
    (TarotSolo *) tarot_solo_alloc_fuzzy (c_fuzziness, c_seed_size, c_seed,
					  c_ai);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Solo (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_add (SCM g_solo, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_solo;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_solo = scm_to_pointer (g_solo);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  c_ret = (TarotGameError) tarot_solo_add (c_solo, c_event);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_copy (SCM g_dest, SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_dest;
  TarotSolo *c_source;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_dest = scm_to_pointer (g_dest);
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  tarot_solo_copy (c_dest, c_source);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_copy_as (SCM g_dest, SCM g_source, SCM g_who)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_dest;
  TarotSolo *c_source;
  TarotPlayer c_who;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_dest = scm_to_pointer (g_dest);
  c_source = scm_to_pointer (g_source);
  c_who = scm_to_typedef_Player (g_who);
/* Calling the function */
  tarot_solo_copy_as (c_dest, c_source, c_who);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_dup (SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_source;
/* Declaration of the type for the return value */
  TarotSolo *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotSolo *) tarot_solo_dup (c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Solo (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_get (SCM g_solo, SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_solo;
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_solo = scm_to_pointer (g_solo);
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_solo_get (c_solo, c_game);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_get_alloc (SCM g_solo)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_solo;
/* Declaration of the type for the return value */
  TarotGame *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_solo = scm_to_pointer (g_solo);
/* Calling the function */
  c_ret = (TarotGame *) tarot_solo_get_alloc (c_solo);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_Game (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_setup (SCM g_solo, SCM g_n_players, SCM g_with_call,
			      SCM g_myself, SCM g_owners, SCM g_taker,
			      SCM g_call)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_solo;
  size_t c_n_players;
  int c_with_call;
  TarotPlayer c_myself;
  size_t c_n_owners;
  TarotPlayer *c_owners;
  TarotPlayer c_taker;
  TarotCard c_call;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_solo = scm_to_pointer (g_solo);
  c_n_players = scm_to_size_t (g_n_players);
  c_with_call = scm_to_bool (g_with_call);
  c_myself = scm_to_typedef_Player (g_myself);
  c_owners = scm_to_array_typedef_Player (&c_n_owners, g_owners);
  c_taker = scm_to_typedef_Player (g_taker);
  c_call = scm_to_typedef_Card (g_call);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_solo_setup (c_solo, c_n_players, c_with_call,
				       c_myself, c_n_owners, c_owners,
				       c_taker, c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_setup_random (SCM g_solo, SCM g_n_players,
				     SCM g_with_call, SCM g_seed)
{
/* Declaration of the types for input parameters */
  TarotSolo *c_solo;
  size_t c_n_players;
  int c_with_call;
  size_t c_seed_size;
  char *c_seed;
/* Declaration of the type for the return value */
  TarotGameError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_solo = scm_to_pointer (g_solo);
  c_n_players = scm_to_size_t (g_n_players);
  c_with_call = scm_to_bool (g_with_call);
  c_seed = scm_to_array_char (&c_seed_size, g_seed);
/* Calling the function */
  c_ret =
    (TarotGameError) tarot_solo_setup_random (c_solo, c_n_players,
					      c_with_call, c_seed_size,
					      c_seed);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_GameError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_solo_construct (SCM g_mem_out)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
/* Calling the function */
  c_ret = (size_t) tarot_solo_construct (c_max_mem, c_mem_out, &c_alignment);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_parser_alloc (SCM g_input)
{
/* Declaration of the types for input parameters */
  char *c_input;
/* Declaration of the type for the return value */
  TarotXmlParser *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_input = scm_to_narrow_string (g_input);
/* Calling the function */
  c_ret = (TarotXmlParser *) tarot_xml_parser_alloc (c_input);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_XmlParser (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_parser_dup (SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotXmlParser *c_source;
/* Declaration of the type for the return value */
  TarotXmlParser *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotXmlParser *) tarot_xml_parser_dup (c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_XmlParser (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_parser_iterator (SCM g_parser)
{
/* Declaration of the types for input parameters */
  TarotXmlParser *c_parser;
/* Declaration of the type for the return value */
  TarotXmlParserIterator *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_parser = scm_to_pointer (g_parser);
/* Calling the function */
  c_ret = (TarotXmlParserIterator *) tarot_xml_parser_iterator (c_parser);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_XmlParserIterator (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_parser_construct (SCM g_mem_out, SCM g_input)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  char *c_input;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_input = scm_to_narrow_string (g_input);
/* Calling the function */
  c_ret =
    (size_t) tarot_xml_parser_construct (c_max_mem, c_mem_out, &c_alignment,
					 c_input);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_parser_iterator_dup (SCM g_source)
{
/* Declaration of the types for input parameters */
  TarotXmlParserIterator *c_source;
/* Declaration of the type for the return value */
  TarotXmlParserIterator *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_source = scm_to_pointer (g_source);
/* Calling the function */
  c_ret = (TarotXmlParserIterator *) tarot_xml_parser_iterator_dup (c_source);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_class_XmlParserIterator (c_ret, 1), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_parser_iterator_next_value (SCM g_iterator)
{
/* Declaration of the types for input parameters */
  TarotXmlParserIterator *c_iterator;
/* Declaration of the type for the return value */
  void *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_iterator = scm_to_pointer (g_iterator);
/* Calling the function */
  c_ret = (void *) tarot_xml_parser_iterator_next_value (c_iterator);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_pointer (c_ret, NULL), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_parser_iterator_construct (SCM g_mem_out, SCM g_parser)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
  TarotXmlParser *c_parser;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
  c_parser = scm_to_pointer (g_parser);
/* Calling the function */
  c_ret =
    (size_t) tarot_xml_parser_iterator_construct (c_max_mem, c_mem_out,
						  &c_alignment, c_parser);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_card_parse (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotCard c_ret;
/* Declaration of the types for output parameters */
  char *c_end = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotCard) tarot_card_parse (c_text, &c_end);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Card (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_narrow_string (c_end), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_card_parse_c (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotCard c_ret;
/* Declaration of the types for output parameters */
  char *c_end = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotCard) tarot_card_parse_c (c_text, &c_end);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Card (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_narrow_string (c_end), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_card_to_string (SCM g_c, SCM g_dest_out)
{
/* Declaration of the types for input parameters */
  TarotCard c_c;
  size_t c_max;
  char *c_dest_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_c = scm_to_typedef_Card (g_c);
  c_dest_out = scm_to_array_char (&c_max, g_dest_out);
/* Calling the function */
  c_ret = (size_t) tarot_card_to_string (c_c, c_max, c_dest_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_card_to_string_alloc (SCM g_c)
{
/* Declaration of the types for input parameters */
  TarotCard c_c;
/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_c = scm_to_typedef_Card (g_c);
/* Calling the function */
  c_ret = (char *) tarot_card_to_string_alloc (c_c);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
  free (c_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_card_to_string_c (SCM g_c, SCM g_dest_out)
{
/* Declaration of the types for input parameters */
  TarotCard c_c;
  size_t c_max;
  char *c_dest_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_c = scm_to_typedef_Card (g_c);
  c_dest_out = scm_to_array_char (&c_max, g_dest_out);
/* Calling the function */
  c_ret = (size_t) tarot_card_to_string_c (c_c, c_max, c_dest_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_card_to_string_c_alloc (SCM g_c)
{
/* Declaration of the types for input parameters */
  TarotCard c_c;
/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_c = scm_to_typedef_Card (g_c);
/* Calling the function */
  c_ret = (char *) tarot_card_to_string_c_alloc (c_c);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
  free (c_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_cnn_predict (SCM g_game, SCM g_score_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_max_score;
  double *c_score_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_score_out = scm_to_array_double (&c_max_score, g_score_out);
/* Calling the function */
  c_ret = (size_t) tarot_cnn_predict (c_game, c_max_score, c_score_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_cnn_predict_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  double *c_score = NULL;
  size_t c_n_score = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_cnn_predict_alloc (c_game, &c_score, &c_n_score);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_array_double (c_n_score, c_score), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_score), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_cnn_predictor_alloc ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  void *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (void *) tarot_cnn_predictor_alloc ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_pointer (c_ret, NULL), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_cnn_predictor_construct (SCM g_mem_out)
{
/* Declaration of the types for input parameters */
  size_t c_max_mem;
  char *c_mem_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */
  size_t c_alignment = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mem_out = scm_to_array_char (&c_max_mem, g_mem_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_cnn_predictor_construct (c_max_mem, c_mem_out,
					    &c_alignment);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_alignment), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_decompose (SCM g_c)
{
/* Declaration of the types for input parameters */
  TarotCard c_c;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */
  TarotNumber c_n = 0;
  TarotSuit c_s = TAROT_HEARTS;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_c = scm_to_typedef_Card (g_c);
/* Calling the function */
  c_ret = (int) tarot_decompose (c_c, &c_n, &c_s);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_int (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Number (c_n), g_ret);
  g_ret = scm_cons (scm_from_enum_Suit (c_s), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_arff_data (SCM g_base, SCM g_added, SCM g_score,
				      SCM g_encoded, SCM g_dest_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_base;
  TarotGameEvent *c_added;
  int c_score;
  int c_encoded;
  size_t c_max;
  char *c_dest_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_base = scm_to_pointer (g_base);
  c_added = scm_to_pointer (g_added);
  c_score = scm_to_int (g_score);
  c_encoded = scm_to_bool (g_encoded);
  c_dest_out = scm_to_array_char (&c_max, g_dest_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_features_arff_data (c_base, c_added, c_score, c_encoded,
				       c_max, c_dest_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_arff_data_alloc (SCM g_base, SCM g_added,
					    SCM g_score, SCM g_encoded)
{
/* Declaration of the types for input parameters */
  TarotGame *c_base;
  TarotGameEvent *c_added;
  int c_score;
  int c_encoded;
/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_base = scm_to_pointer (g_base);
  c_added = scm_to_pointer (g_added);
  c_score = scm_to_int (g_score);
  c_encoded = scm_to_bool (g_encoded);
/* Calling the function */
  c_ret =
    (char *) tarot_features_arff_data_alloc (c_base, c_added, c_score,
					     c_encoded);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
  free (c_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_arff_header (SCM g_encoded)
{
/* Declaration of the types for input parameters */
  int c_encoded;
/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_encoded = scm_to_bool (g_encoded);
/* Calling the function */
  c_ret = (char *) tarot_features_arff_header (c_encoded);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_bid_minimum (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  TarotBid c_minimum = TAROT_PASS;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_bid_minimum (c_game, &c_minimum);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_enum_Bid (c_minimum), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_cnn_add (SCM g_game, SCM g_data_out)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_max;
  double *c_data_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_data_out = scm_to_array_double (&c_max, g_data_out);
/* Calling the function */
  c_ret = (size_t) tarot_features_cnn_add (c_game, c_max, c_data_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_cnn_alloc (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  double *c_data = NULL;
  size_t c_n = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_cnn_alloc (c_game, &c_data, &c_n);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_array_double (c_n, c_data), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_count_faces (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_kings = 0;
  size_t c_n_marriages = 0;
  size_t c_n_extended_marriages = 0;
  size_t c_n_queens = 0;
  size_t c_n_knights = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_count_faces (c_game, &c_n_kings, &c_n_marriages,
			      &c_n_extended_marriages, &c_n_queens,
			      &c_n_knights);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_kings), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_marriages), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_extended_marriages), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_queens), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_knights), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_count_minor (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_shortest = 0;
  size_t c_n_second_shortest = 0;
  size_t c_n_second_longest = 0;
  size_t c_n_longest = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_count_minor (c_game, &c_n_shortest, &c_n_second_shortest,
			      &c_n_second_longest, &c_n_longest);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_shortest), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_second_shortest), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_second_longest), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_longest), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_count_oudlers (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_has_petit = 0;
  int c_has_excuse = 0;
  int c_has_twentyone = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_count_oudlers (c_game, &c_has_petit, &c_has_excuse,
				&c_has_twentyone);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_has_petit), g_ret);
  g_ret = scm_cons (scm_from_bool (c_has_excuse), g_ret);
  g_ret = scm_cons (scm_from_bool (c_has_twentyone), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_count_trumps (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_trumps = 0;
  TarotNumber c_max_trump = 0;
  TarotNumber c_min_trump = 0;
  TarotNumber c_q1_trumps = 0;
  TarotNumber c_q3_trumps = 0;
  TarotNumber c_median_trumps = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_count_trumps (c_game, &c_n_trumps, &c_max_trump,
			       &c_min_trump, &c_q1_trumps, &c_q3_trumps,
			       &c_median_trumps);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_trumps), g_ret);
  g_ret = scm_cons (scm_from_typedef_Number (c_max_trump), g_ret);
  g_ret = scm_cons (scm_from_typedef_Number (c_min_trump), g_ret);
  g_ret = scm_cons (scm_from_typedef_Number (c_q1_trumps), g_ret);
  g_ret = scm_cons (scm_from_typedef_Number (c_q3_trumps), g_ret);
  g_ret = scm_cons (scm_from_typedef_Number (c_median_trumps), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_errors (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */
  double c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (double) tarot_features_errors (c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_double (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_minor_suit (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_called_suit = 0;
  size_t c_n_times_lead = 0;
  size_t c_n_remaining_cards = 0;
  size_t c_n_remaining_points = 0;
  int c_ally_may_be_master = 0;
  int c_ennemy_may_be_master = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_minor_suit (c_game, &c_called_suit, &c_n_times_lead,
			     &c_n_remaining_cards, &c_n_remaining_points,
			     &c_ally_may_be_master, &c_ennemy_may_be_master);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_called_suit), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_times_lead), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_remaining_cards), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_remaining_points), g_ret);
  g_ret = scm_cons (scm_from_bool (c_ally_may_be_master), g_ret);
  g_ret = scm_cons (scm_from_bool (c_ennemy_may_be_master), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_partner_known (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_known = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_partner_known (c_game, &c_known);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_known), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_points (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_halfpoints = 0;
  size_t c_n_oudlers = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_points (c_game, &c_n_halfpoints, &c_n_oudlers);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_halfpoints), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_oudlers), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_position (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_i_trick = 0;
  size_t c_position = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_position (c_game, &c_i_trick, &c_position);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_i_trick), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_position), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_strongest_player (SCM g_n_players, SCM g_with_call,
					     SCM g_owners)
{
/* Declaration of the types for input parameters */
  size_t c_n_players;
  int c_with_call;
  size_t c_n_cards;
  TarotPlayer *c_owners;
/* Declaration of the type for the return value */
  TarotPlayer c_ret;
/* Declaration of the types for output parameters */
  double c_confidence = 0;
  TarotCard c_call = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_n_players = scm_to_size_t (g_n_players);
  c_with_call = scm_to_bool (g_with_call);
  c_owners = scm_to_array_typedef_Player (&c_n_cards, g_owners);
/* Calling the function */
  c_ret =
    (TarotPlayer) tarot_features_strongest_player (c_n_players, c_with_call,
						   c_n_cards, c_owners,
						   &c_confidence, &c_call);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Player (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_double (c_confidence), g_ret);
  g_ret = scm_cons (scm_from_typedef_Card (c_call), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_team (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_attack = 0;
  int c_defence = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_team (c_game, &c_attack, &c_defence);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_attack), g_ret);
  g_ret = scm_cons (scm_from_bool (c_defence), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_trick_players (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_already_played = 0;
  size_t c_n_allies_after_last_opponent = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_trick_players (c_game, &c_n_already_played,
				&c_n_allies_after_last_opponent);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_already_played), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_allies_after_last_opponent), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_trump (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_remaining = 0;
  int c_ally_may_be_master = 0;
  int c_ennemy_may_be_master = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_trump (c_game, &c_n_remaining, &c_ally_may_be_master,
			&c_ennemy_may_be_master);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_remaining), g_ret);
  g_ret = scm_cons (scm_from_bool (c_ally_may_be_master), g_ret);
  g_ret = scm_cons (scm_from_bool (c_ennemy_may_be_master), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_features_variant (SCM g_game)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_players = 0;
  int c_with_call = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  tarot_features_variant (c_game, &c_n_players, &c_with_call);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_players), g_ret);
  g_ret = scm_cons (scm_from_bool (c_with_call), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_init (SCM g_localedir)
{
/* Declaration of the types for input parameters */
  char *c_localedir;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_localedir = scm_to_narrow_string (g_localedir);
/* Calling the function */
  c_ret = (int) tarot_init (c_localedir);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_int (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_layout_center (SCM g_view_w, SCM g_view_h, SCM g_card_w,
				 SCM g_card_h, SCM g_n_cards, SCM g_start,
				 SCM g_position_out)
{
/* Declaration of the types for input parameters */
  double c_view_w;
  double c_view_h;
  double c_card_w;
  double c_card_h;
  size_t c_n_cards;
  size_t c_max;
  size_t c_start;
  TarotPosition *c_position_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_view_w = scm_to_double (g_view_w);
  c_view_h = scm_to_double (g_view_h);
  c_card_w = scm_to_double (g_card_w);
  c_card_h = scm_to_double (g_card_h);
  c_n_cards = scm_to_size_t (g_n_cards);
  c_start = scm_to_size_t (g_start);
  c_position_out = scm_to_array_struct_Position (&c_max, g_position_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_layout_center (c_view_w, c_view_h, c_card_w, c_card_h,
				  c_n_cards, c_max, c_start, c_position_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_layout_center_alloc (SCM g_view_w, SCM g_view_h,
				       SCM g_card_w, SCM g_card_h,
				       SCM g_n_cards)
{
/* Declaration of the types for input parameters */
  double c_view_w;
  double c_view_h;
  double c_card_w;
  double c_card_h;
  size_t c_n_cards;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_positions = 0;
  TarotPosition *c_positions = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_view_w = scm_to_double (g_view_w);
  c_view_h = scm_to_double (g_view_h);
  c_card_w = scm_to_double (g_card_w);
  c_card_h = scm_to_double (g_card_h);
  c_n_cards = scm_to_size_t (g_n_cards);
/* Calling the function */
  tarot_layout_center_alloc (c_view_w, c_view_h, c_card_w, c_card_h,
			     c_n_cards, &c_n_positions, &c_positions);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_positions), g_ret);
  g_ret =
    scm_cons (scm_from_array_struct_Position (c_n_positions, c_positions),
	      g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_layout_hand (SCM g_view_w, SCM g_view_h, SCM g_card_w,
			       SCM g_card_h, SCM g_n_cards, SCM g_start,
			       SCM g_position_out)
{
/* Declaration of the types for input parameters */
  double c_view_w;
  double c_view_h;
  double c_card_w;
  double c_card_h;
  size_t c_n_cards;
  size_t c_max;
  size_t c_start;
  TarotPosition *c_position_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_view_w = scm_to_double (g_view_w);
  c_view_h = scm_to_double (g_view_h);
  c_card_w = scm_to_double (g_card_w);
  c_card_h = scm_to_double (g_card_h);
  c_n_cards = scm_to_size_t (g_n_cards);
  c_start = scm_to_size_t (g_start);
  c_position_out = scm_to_array_struct_Position (&c_max, g_position_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_layout_hand (c_view_w, c_view_h, c_card_w, c_card_h,
				c_n_cards, c_max, c_start, c_position_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_layout_hand_alloc (SCM g_view_w, SCM g_view_h, SCM g_card_w,
				     SCM g_card_h, SCM g_n_cards)
{
/* Declaration of the types for input parameters */
  double c_view_w;
  double c_view_h;
  double c_card_w;
  double c_card_h;
  size_t c_n_cards;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_positions = 0;
  TarotPosition *c_positions = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_view_w = scm_to_double (g_view_w);
  c_view_h = scm_to_double (g_view_h);
  c_card_w = scm_to_double (g_card_w);
  c_card_h = scm_to_double (g_card_h);
  c_n_cards = scm_to_size_t (g_n_cards);
/* Calling the function */
  tarot_layout_hand_alloc (c_view_w, c_view_h, c_card_w, c_card_h, c_n_cards,
			   &c_n_positions, &c_positions);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_positions), g_ret);
  g_ret =
    scm_cons (scm_from_array_struct_Position (c_n_positions, c_positions),
	      g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_layout_position (SCM g_view_w, SCM g_view_h, SCM g_card_w,
				   SCM g_card_h, SCM g_n_my_cards,
				   SCM g_n_adv_cards, SCM g_n_center,
				   SCM g_dst_out)
{
/* Declaration of the types for input parameters */
  double c_view_w;
  double c_view_h;
  double c_card_w;
  double c_card_h;
  size_t c_n_my_cards;
  size_t c_n_adversaries;
  size_t *c_n_adv_cards;
  size_t c_n_center;
  size_t c_max_dst;
  TarotPosition *c_dst_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_view_w = scm_to_double (g_view_w);
  c_view_h = scm_to_double (g_view_h);
  c_card_w = scm_to_double (g_card_w);
  c_card_h = scm_to_double (g_card_h);
  c_n_my_cards = scm_to_size_t (g_n_my_cards);
  c_n_adv_cards = scm_to_array_size_t (&c_n_adversaries, g_n_adv_cards);
  c_n_center = scm_to_size_t (g_n_center);
  c_dst_out = scm_to_array_struct_Position (&c_max_dst, g_dst_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_layout_position (c_view_w, c_view_h, c_card_w, c_card_h,
				    c_n_my_cards, c_n_adversaries,
				    c_n_adv_cards, c_n_center, c_max_dst,
				    c_dst_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_layout_trick (SCM g_view_w, SCM g_view_h, SCM g_card_w,
				SCM g_card_h, SCM g_n_players, SCM g_start,
				SCM g_position_out)
{
/* Declaration of the types for input parameters */
  double c_view_w;
  double c_view_h;
  double c_card_w;
  double c_card_h;
  size_t c_n_players;
  size_t c_max;
  size_t c_start;
  TarotPosition *c_position_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_view_w = scm_to_double (g_view_w);
  c_view_h = scm_to_double (g_view_h);
  c_card_w = scm_to_double (g_card_w);
  c_card_h = scm_to_double (g_card_h);
  c_n_players = scm_to_size_t (g_n_players);
  c_start = scm_to_size_t (g_start);
  c_position_out = scm_to_array_struct_Position (&c_max, g_position_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_layout_trick (c_view_w, c_view_h, c_card_w, c_card_h,
				 c_n_players, c_max, c_start, c_position_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_layout_trick_alloc (SCM g_view_w, SCM g_view_h,
				      SCM g_card_w, SCM g_card_h,
				      SCM g_n_players)
{
/* Declaration of the types for input parameters */
  double c_view_w;
  double c_view_h;
  double c_card_w;
  double c_card_h;
  size_t c_n_players;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_positions = 0;
  TarotPosition *c_positions = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_view_w = scm_to_double (g_view_w);
  c_view_h = scm_to_double (g_view_h);
  c_card_w = scm_to_double (g_card_w);
  c_card_h = scm_to_double (g_card_h);
  c_n_players = scm_to_size_t (g_n_players);
/* Calling the function */
  tarot_layout_trick_alloc (c_view_w, c_view_h, c_card_w, c_card_h,
			    c_n_players, &c_n_positions, &c_positions);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_positions), g_ret);
  g_ret =
    scm_cons (scm_from_array_struct_Position (c_n_positions, c_positions),
	      g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_libtarot_version ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  c_ret = (char *) tarot_libtarot_version ();
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_of (SCM g_number, SCM g_suit)
{
/* Declaration of the types for input parameters */
  TarotNumber c_number;
  TarotSuit c_suit;
/* Declaration of the type for the return value */
  int c_ret;
/* Declaration of the types for output parameters */
  TarotCard c_card = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_number = scm_to_typedef_Number (g_number);
  c_suit = scm_to_enum_Suit (g_suit);
/* Calling the function */
  c_ret = (int) tarot_of (c_number, c_suit, &c_card);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_int (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_typedef_Card (c_card), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_player_parse (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotPlayer c_ret;
/* Declaration of the types for output parameters */
  char *c_end = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotPlayer) tarot_player_parse (c_text, &c_end);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Player (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_narrow_string (c_end), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_player_parse_c (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotPlayer c_ret;
/* Declaration of the types for output parameters */
  char *c_end = NULL;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotPlayer) tarot_player_parse_c (c_text, &c_end);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Player (c_ret), g_ret);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_narrow_string (c_end), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_player_to_string (SCM g_p, SCM g_dest_out)
{
/* Declaration of the types for input parameters */
  TarotPlayer c_p;
  size_t c_max;
  char *c_dest_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_p = scm_to_typedef_Player (g_p);
  c_dest_out = scm_to_array_char (&c_max, g_dest_out);
/* Calling the function */
  c_ret = (size_t) tarot_player_to_string (c_p, c_max, c_dest_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_player_to_string_alloc (SCM g_p)
{
/* Declaration of the types for input parameters */
  TarotPlayer c_p;
/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_p = scm_to_typedef_Player (g_p);
/* Calling the function */
  c_ret = (char *) tarot_player_to_string_alloc (c_p);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
  free (c_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_player_to_string_c (SCM g_p, SCM g_dest_out)
{
/* Declaration of the types for input parameters */
  TarotPlayer c_p;
  size_t c_max;
  char *c_dest_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_p = scm_to_typedef_Player (g_p);
  c_dest_out = scm_to_array_char (&c_max, g_dest_out);
/* Calling the function */
  c_ret = (size_t) tarot_player_to_string_c (c_p, c_max, c_dest_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_player_to_string_c_alloc (SCM g_p)
{
/* Declaration of the types for input parameters */
  TarotPlayer c_p;
/* Declaration of the type for the return value */
  char *c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_p = scm_to_typedef_Player (g_p);
/* Calling the function */
  c_ret = (char *) tarot_player_to_string_c_alloc (c_p);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_narrow_string (c_ret), g_ret);
  free (c_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_quit ()
{
/* Declaration of the types for input parameters */

/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */

/* Calling the function */
  tarot_quit ();
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_set_datadir (SCM g_datadir)
{
/* Declaration of the types for input parameters */
  char *c_datadir;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_datadir = scm_to_narrow_string (g_datadir);
/* Calling the function */
  tarot_set_datadir (c_datadir);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_simulate (SCM g_prng, SCM g_game)
{
/* Declaration of the types for input parameters */
  void *c_prng;
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotSimulationError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_prng = scm_to_pointer (g_prng);
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotSimulationError) tarot_simulate (c_prng, c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_SimulationError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_simulate_agreed (SCM g_prng, SCM g_game)
{
/* Declaration of the types for input parameters */
  void *c_prng;
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotSimulationError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_prng = scm_to_pointer (g_prng);
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotSimulationError) tarot_simulate_agreed (c_prng, c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_SimulationError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_simulate_random (SCM g_prng, SCM g_game)
{
/* Declaration of the types for input parameters */
  void *c_prng;
  TarotGame *c_game;
/* Declaration of the type for the return value */
  TarotSimulationError c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_prng = scm_to_pointer (g_prng);
  c_game = scm_to_pointer (g_game);
/* Calling the function */
  c_ret = (TarotSimulationError) tarot_simulate_random (c_prng, c_game);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_enum_SimulationError (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_bid (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  TarotBid c_bid = TAROT_PASS;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_bid (c_game, c_event, &c_bid);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_enum_Bid (c_bid), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_call_by_length (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_shortest = 0;
  int c_second_shortest = 0;
  int c_second_longest = 0;
  int c_longest = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_call_by_length (c_game, c_event, &c_shortest,
				 &c_second_shortest, &c_second_longest,
				 &c_longest);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_shortest), g_ret);
  g_ret = scm_cons (scm_from_bool (c_second_shortest), g_ret);
  g_ret = scm_cons (scm_from_bool (c_second_longest), g_ret);
  g_ret = scm_cons (scm_from_bool (c_longest), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_call_marriage (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_will_own_marriage = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_call_marriage (c_game, c_event, &c_will_own_marriage);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_will_own_marriage), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_call_myself (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_myself = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_call_myself (c_game, c_event, &c_myself);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_myself), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_discard_by_length (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_from_shortest = 0;
  size_t c_from_second_shortest = 0;
  size_t c_from_second_longest = 0;
  size_t c_from_longest = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_discard_by_length (c_game, c_event, &c_from_shortest,
				    &c_from_second_shortest,
				    &c_from_second_longest, &c_from_longest);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_from_shortest), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_from_second_shortest), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_from_second_longest), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_from_longest), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_discard_junk (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_lesser_cards_left_behind = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_discard_junk (c_game, c_event,
			       &c_n_lesser_cards_left_behind);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_lesser_cards_left_behind), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_discard_save (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_queens_saved = 0;
  size_t c_n_knights_saved = 0;
  size_t c_n_jacks_saved = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_discard_save (c_game, c_event, &c_n_queens_saved,
			       &c_n_knights_saved, &c_n_jacks_saved);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_queens_saved), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_knights_saved), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_jacks_saved), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_excuse (SCM g_game, SCM g_card)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_card;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_excuse = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_card = scm_to_pointer (g_card);
/* Calling the function */
  tarot_strategy_excuse (c_game, c_card, &c_excuse);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_excuse), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_lead (SCM g_game, SCM g_card)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_card;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_called_suit = 0;
  size_t c_suit_length = 0;
  size_t c_n_times_lead = 0;
  int c_trumps = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_card = scm_to_pointer (g_card);
/* Calling the function */
  tarot_strategy_lead (c_game, c_card, &c_called_suit, &c_suit_length,
		       &c_n_times_lead, &c_trumps);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_called_suit), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_suit_length), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_times_lead), g_ret);
  g_ret = scm_cons (scm_from_bool (c_trumps), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_outbid (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_outbid = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_outbid (c_game, c_event, &c_outbid);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_int (c_outbid), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_play_points (SCM g_game, SCM g_card)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_card;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_halfpoints = 0;
  int c_oudler = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_card = scm_to_pointer (g_card);
/* Calling the function */
  tarot_strategy_play_points (c_game, c_card, &c_n_halfpoints, &c_oudler);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_halfpoints), g_ret);
  g_ret = scm_cons (scm_from_bool (c_oudler), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_purity (SCM g_game, SCM g_event)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_event;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  size_t c_n_smaller_kept = 0;
  size_t c_n_greater_nonface_kept = 0;
  size_t c_n_points_kept = 0;
  size_t c_n_greater_kept = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_event = scm_to_pointer (g_event);
/* Calling the function */
  tarot_strategy_purity (c_game, c_event, &c_n_smaller_kept,
			 &c_n_greater_nonface_kept, &c_n_points_kept,
			 &c_n_greater_kept);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_size_t (c_n_smaller_kept), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_greater_nonface_kept), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_points_kept), g_ret);
  g_ret = scm_cons (scm_from_size_t (c_n_greater_kept), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_strategy_trump_master (SCM g_game, SCM g_card)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  TarotGameEvent *c_card;
/* Declaration of the type for the return value */

/* There is no return value for this function */

/* Declaration of the types for output parameters */
  int c_actually_master = 0;
  int c_obvious_master = 0;
/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_card = scm_to_pointer (g_card);
/* Calling the function */
  tarot_strategy_trump_master (c_game, c_card, &c_actually_master,
			       &c_obvious_master);
/* Pushing the output parameters */
  g_ret = scm_cons (scm_from_bool (c_actually_master), g_ret);
  g_ret = scm_cons (scm_from_bool (c_obvious_master), g_ret);
/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_string_to_card (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotCard c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotCard) tarot_string_to_card (c_text);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Card (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_string_to_card_c (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotCard c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotCard) tarot_string_to_card_c (c_text);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Card (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_string_to_player (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotPlayer c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotPlayer) tarot_string_to_player (c_text);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Player (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_string_to_player_c (SCM g_text)
{
/* Declaration of the types for input parameters */
  char *c_text;
/* Declaration of the type for the return value */
  TarotPlayer c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_text = scm_to_narrow_string (g_text);
/* Calling the function */
  c_ret = (TarotPlayer) tarot_string_to_player_c (c_text);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_typedef_Player (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_save (SCM g_game, SCM g_start, SCM g_max, SCM g_dest)
{
/* Declaration of the types for input parameters */
  TarotGame *c_game;
  size_t c_start;
  size_t c_max;
  char *c_dest;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_game = scm_to_pointer (g_game);
  c_start = scm_to_size_t (g_start);
  c_max = scm_to_size_t (g_max);
  c_dest = scm_to_narrow_string (g_dest);
/* Calling the function */
  c_ret = (size_t) tarot_xml_save (c_game, c_start, c_max, c_dest);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

static SCM
tarot_guile_tarot_xml_save_mcts_tree (SCM g_mcts, SCM g_start, SCM g_dest_out)
{
/* Declaration of the types for input parameters */
  TarotMcts *c_mcts;
  size_t c_start;
  size_t c_max;
  char *c_dest_out;
/* Declaration of the type for the return value */
  size_t c_ret;
/* Declaration of the types for output parameters */

/* Declaration of the return value */
  SCM g_ret = SCM_EOL;
/* Binding the input parameters */
  c_mcts = scm_to_pointer (g_mcts);
  c_start = scm_to_size_t (g_start);
  c_dest_out = scm_to_array_char (&c_max, g_dest_out);
/* Calling the function */
  c_ret =
    (size_t) tarot_xml_save_mcts_tree (c_mcts, c_start, c_max, c_dest_out);
/* Pushing the return value */
  g_ret = scm_cons (scm_from_size_t (c_ret), g_ret);
/* Pushing the output parameters */

/* Returning */
  if (scm_to_size_t (scm_length (g_ret)) == 0)
    {
      return SCM_UNDEFINED;
    }
  if (scm_to_size_t (scm_length (g_ret)) == 1)
    {
      return scm_car (g_ret);
    }
  return scm_reverse (g_ret);
}

void
tarot_guile_init ()
{
  scm_c_define_gsubr ("tarot-ai-alloc-fuzzy", 3, 0, 0,
		      tarot_guile_tarot_ai_alloc_fuzzy);
  scm_c_define_gsubr ("tarot-ai-alloc-perceptron", 0, 0, 0,
		      tarot_guile_tarot_ai_alloc_perceptron);
  scm_c_define_gsubr ("tarot-ai-alloc-random", 1, 0, 0,
		      tarot_guile_tarot_ai_alloc_random);
  scm_c_define_gsubr ("tarot-ai-best", 2, 0, 0, tarot_guile_tarot_ai_best);
  scm_c_define_gsubr ("tarot-ai-dup", 1, 0, 0, tarot_guile_tarot_ai_dup);
  scm_c_define_gsubr ("tarot-ai-eval", 5, 0, 0, tarot_guile_tarot_ai_eval);
  scm_c_define_gsubr ("tarot-ai-learn", 4, 0, 0, tarot_guile_tarot_ai_learn);
  scm_c_define_gsubr ("tarot-ai-strongest-player", 4, 0, 0,
		      tarot_guile_tarot_ai_strongest_player);
  scm_c_define_gsubr ("tarot-ai-validate", 2, 0, 0,
		      tarot_guile_tarot_ai_validate);
  scm_c_define_gsubr ("tarot-ai-alloc", 5, 0, 0, tarot_guile_tarot_ai_alloc);
  scm_c_define_gsubr ("tarot-bid-check", 2, 0, 0,
		      tarot_guile_tarot_bid_check);
  scm_c_define_gsubr ("tarot-bid-discard-allowed", 1, 0, 0,
		      tarot_guile_tarot_bid_discard_allowed);
  scm_c_define_gsubr ("tarot-bid-discard-counted", 1, 0, 0,
		      tarot_guile_tarot_bid_discard_counted);
  scm_c_define_gsubr ("tarot-bid-multiplier", 1, 0, 0,
		      tarot_guile_tarot_bid_multiplier);
  scm_c_define_gsubr ("tarot-counter-alloc", 0, 0, 0,
		      tarot_guile_tarot_counter_alloc);
  scm_c_define_gsubr ("tarot-counter-and-game-impute", 3, 0, 0,
		      tarot_guile_tarot_counter_and_game_impute);
  scm_c_define_gsubr ("tarot-counter-and-game-impute-likely", 4, 0, 0,
		      tarot_guile_tarot_counter_and_game_impute_likely);
  scm_c_define_gsubr ("tarot-counter-copy", 2, 0, 0,
		      tarot_guile_tarot_counter_copy);
  scm_c_define_gsubr ("tarot-counter-dup", 1, 0, 0,
		      tarot_guile_tarot_counter_dup);
  scm_c_define_gsubr ("tarot-counter-load-from-game", 2, 0, 0,
		      tarot_guile_tarot_counter_load_from_game);
  scm_c_define_gsubr ("tarot-counter-may-be-in-doscard", 2, 0, 0,
		      tarot_guile_tarot_counter_may_be_in_doscard);
  scm_c_define_gsubr ("tarot-counter-may-own", 3, 0, 0,
		      tarot_guile_tarot_counter_may_own);
  scm_c_define_gsubr ("tarot-counter-n-cards-doscard", 1, 0, 0,
		      tarot_guile_tarot_counter_n_cards_doscard);
  scm_c_define_gsubr ("tarot-counter-n-cards-remaining", 2, 0, 0,
		      tarot_guile_tarot_counter_n_cards_remaining);
  scm_c_define_gsubr ("tarot-counter-construct", 1, 0, 0,
		      tarot_guile_tarot_counter_construct);
  scm_c_define_gsubr ("tarot-game-alloc", 0, 0, 0,
		      tarot_guile_tarot_game_alloc);
  scm_c_define_gsubr ("tarot-game-add-event", 2, 0, 0,
		      tarot_guile_tarot_game_add_event);
  scm_c_define_gsubr ("tarot-game-assign-missing-card", 3, 0, 0,
		      tarot_guile_tarot_game_assign_missing_card);
  scm_c_define_gsubr ("tarot-game-can-autoreveal", 3, 0, 0,
		      tarot_guile_tarot_game_can_autoreveal);
  scm_c_define_gsubr ("tarot-game-can-autoreveal-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_can_autoreveal_alloc);
  scm_c_define_gsubr ("tarot-game-check-card", 2, 0, 0,
		      tarot_guile_tarot_game_check_card);
  scm_c_define_gsubr ("tarot-game-check-event", 2, 0, 0,
		      tarot_guile_tarot_game_check_event);
  scm_c_define_gsubr ("tarot-game-copy", 2, 0, 0,
		      tarot_guile_tarot_game_copy);
  scm_c_define_gsubr ("tarot-game-copy-as", 3, 0, 0,
		      tarot_guile_tarot_game_copy_as);
  scm_c_define_gsubr ("tarot-game-dup", 1, 0, 0, tarot_guile_tarot_game_dup);
  scm_c_define_gsubr ("tarot-game-duplicate-set-call", 2, 0, 0,
		      tarot_guile_tarot_game_duplicate_set_call);
  scm_c_define_gsubr ("tarot-game-duplicate-set-deal", 2, 0, 0,
		      tarot_guile_tarot_game_duplicate_set_deal);
  scm_c_define_gsubr ("tarot-game-duplicate-set-taker", 2, 0, 0,
		      tarot_guile_tarot_game_duplicate_set_taker);
  scm_c_define_gsubr ("tarot-game-get-bids", 3, 0, 0,
		      tarot_guile_tarot_game_get_bids);
  scm_c_define_gsubr ("tarot-game-get-bids-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_bids_alloc);
  scm_c_define_gsubr ("tarot-game-get-call", 1, 0, 0,
		      tarot_guile_tarot_game_get_call);
  scm_c_define_gsubr ("tarot-game-get-cards", 4, 0, 0,
		      tarot_guile_tarot_game_get_cards);
  scm_c_define_gsubr ("tarot-game-get-cards-alloc", 2, 0, 0,
		      tarot_guile_tarot_game_get_cards_alloc);
  scm_c_define_gsubr ("tarot-game-get-current-trick", 1, 0, 0,
		      tarot_guile_tarot_game_get_current_trick);
  scm_c_define_gsubr ("tarot-game-get-deal-all", 3, 0, 0,
		      tarot_guile_tarot_game_get_deal_all);
  scm_c_define_gsubr ("tarot-game-get-deal-all-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_deal_all_alloc);
  scm_c_define_gsubr ("tarot-game-get-deal-of", 4, 0, 0,
		      tarot_guile_tarot_game_get_deal_of);
  scm_c_define_gsubr ("tarot-game-get-deal-of-alloc", 2, 0, 0,
		      tarot_guile_tarot_game_get_deal_of_alloc);
  scm_c_define_gsubr ("tarot-game-get-declarant", 1, 0, 0,
		      tarot_guile_tarot_game_get_declarant);
  scm_c_define_gsubr ("tarot-game-get-declarations", 3, 0, 0,
		      tarot_guile_tarot_game_get_declarations);
  scm_c_define_gsubr ("tarot-game-get-declarations-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_declarations_alloc);
  scm_c_define_gsubr ("tarot-game-get-dog", 3, 0, 0,
		      tarot_guile_tarot_game_get_dog);
  scm_c_define_gsubr ("tarot-game-get-dog-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_dog_alloc);
  scm_c_define_gsubr ("tarot-game-get-full-discard", 3, 0, 0,
		      tarot_guile_tarot_game_get_full_discard);
  scm_c_define_gsubr ("tarot-game-get-full-discard-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_full_discard_alloc);
  scm_c_define_gsubr ("tarot-game-get-handful", 4, 0, 0,
		      tarot_guile_tarot_game_get_handful);
  scm_c_define_gsubr ("tarot-game-get-handful-alloc", 2, 0, 0,
		      tarot_guile_tarot_game_get_handful_alloc);
  scm_c_define_gsubr ("tarot-game-get-hint-bid", 1, 0, 0,
		      tarot_guile_tarot_game_get_hint_bid);
  scm_c_define_gsubr ("tarot-game-get-hint-call", 1, 0, 0,
		      tarot_guile_tarot_game_get_hint_call);
  scm_c_define_gsubr ("tarot-game-get-hint-card", 3, 0, 0,
		      tarot_guile_tarot_game_get_hint_card);
  scm_c_define_gsubr ("tarot-game-get-hint-card-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_hint_card_alloc);
  scm_c_define_gsubr ("tarot-game-get-hint-decl", 1, 0, 0,
		      tarot_guile_tarot_game_get_hint_decl);
  scm_c_define_gsubr ("tarot-game-get-hint-discard", 5, 0, 0,
		      tarot_guile_tarot_game_get_hint_discard);
  scm_c_define_gsubr ("tarot-game-get-hint-discard-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_hint_discard_alloc);
  scm_c_define_gsubr ("tarot-game-get-hint-handful", 5, 0, 0,
		      tarot_guile_tarot_game_get_hint_handful);
  scm_c_define_gsubr ("tarot-game-get-hint-handful-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_hint_handful_alloc);
  scm_c_define_gsubr ("tarot-game-get-lead-suit", 2, 0, 0,
		      tarot_guile_tarot_game_get_lead_suit);
  scm_c_define_gsubr ("tarot-game-get-main-player", 1, 0, 0,
		      tarot_guile_tarot_game_get_main_player);
  scm_c_define_gsubr ("tarot-game-get-max-trump", 2, 0, 0,
		      tarot_guile_tarot_game_get_max_trump);
  scm_c_define_gsubr ("tarot-game-get-next", 1, 0, 0,
		      tarot_guile_tarot_game_get_next);
  scm_c_define_gsubr ("tarot-game-get-partner", 1, 0, 0,
		      tarot_guile_tarot_game_get_partner);
  scm_c_define_gsubr ("tarot-game-get-points-in-trick", 2, 0, 0,
		      tarot_guile_tarot_game_get_points_in_trick);
  scm_c_define_gsubr ("tarot-game-get-public-discard", 3, 0, 0,
		      tarot_guile_tarot_game_get_public_discard);
  scm_c_define_gsubr ("tarot-game-get-public-discard-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_public_discard_alloc);
  scm_c_define_gsubr ("tarot-game-get-scores", 3, 0, 0,
		      tarot_guile_tarot_game_get_scores);
  scm_c_define_gsubr ("tarot-game-get-scores-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_get_scores_alloc);
  scm_c_define_gsubr ("tarot-game-get-taker", 1, 0, 0,
		      tarot_guile_tarot_game_get_taker);
  scm_c_define_gsubr ("tarot-game-get-trick-cards", 4, 0, 0,
		      tarot_guile_tarot_game_get_trick_cards);
  scm_c_define_gsubr ("tarot-game-get-trick-cards-alloc", 2, 0, 0,
		      tarot_guile_tarot_game_get_trick_cards_alloc);
  scm_c_define_gsubr ("tarot-game-get-trick-leader", 2, 0, 0,
		      tarot_guile_tarot_game_get_trick_leader);
  scm_c_define_gsubr ("tarot-game-get-trick-taker", 2, 0, 0,
		      tarot_guile_tarot_game_get_trick_taker);
  scm_c_define_gsubr ("tarot-game-iterator", 1, 0, 0,
		      tarot_guile_tarot_game_iterator);
  scm_c_define_gsubr ("tarot-game-load-from-xml", 2, 0, 0,
		      tarot_guile_tarot_game_load_from_xml);
  scm_c_define_gsubr ("tarot-game-n-players", 1, 0, 0,
		      tarot_guile_tarot_game_n_players);
  scm_c_define_gsubr ("tarot-game-n-tricks", 1, 0, 0,
		      tarot_guile_tarot_game_n_tricks);
  scm_c_define_gsubr ("tarot-game-save-to-xml", 3, 0, 0,
		      tarot_guile_tarot_game_save_to_xml);
  scm_c_define_gsubr ("tarot-game-save-to-xml-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_save_to_xml_alloc);
  scm_c_define_gsubr ("tarot-game-step", 1, 0, 0,
		      tarot_guile_tarot_game_step);
  scm_c_define_gsubr ("tarot-game-with-call", 1, 0, 0,
		      tarot_guile_tarot_game_with_call);
  scm_c_define_gsubr ("tarot-game-construct", 1, 0, 0,
		      tarot_guile_tarot_game_construct);
  scm_c_define_gsubr ("tarot-game-event-alloc-bid", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_bid);
  scm_c_define_gsubr ("tarot-game-event-alloc-call", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_call);
  scm_c_define_gsubr ("tarot-game-event-alloc-card", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_card);
  scm_c_define_gsubr ("tarot-game-event-alloc-deal", 2, 0, 0,
		      tarot_guile_tarot_game_event_alloc_deal);
  scm_c_define_gsubr ("tarot-game-event-alloc-deal-all", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_deal_all);
  scm_c_define_gsubr ("tarot-game-event-alloc-deal-all-random", 2, 0, 0,
		      tarot_guile_tarot_game_event_alloc_deal_all_random);
  scm_c_define_gsubr ("tarot-game-event-alloc-decl", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_decl);
  scm_c_define_gsubr ("tarot-game-event-alloc-discard", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_discard);
  scm_c_define_gsubr ("tarot-game-event-alloc-dog", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_dog);
  scm_c_define_gsubr ("tarot-game-event-alloc-handful", 1, 0, 0,
		      tarot_guile_tarot_game_event_alloc_handful);
  scm_c_define_gsubr ("tarot-game-event-alloc-setup", 2, 0, 0,
		      tarot_guile_tarot_game_event_alloc_setup);
  scm_c_define_gsubr ("tarot-game-event-dup", 1, 0, 0,
		      tarot_guile_tarot_game_event_dup);
  scm_c_define_gsubr ("tarot-game-event-get-bid", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_bid);
  scm_c_define_gsubr ("tarot-game-event-get-call", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_call);
  scm_c_define_gsubr ("tarot-game-event-get-card", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_card);
  scm_c_define_gsubr ("tarot-game-event-get-deal", 3, 0, 0,
		      tarot_guile_tarot_game_event_get_deal);
  scm_c_define_gsubr ("tarot-game-event-get-deal-all", 3, 0, 0,
		      tarot_guile_tarot_game_event_get_deal_all);
  scm_c_define_gsubr ("tarot-game-event-get-deal-all-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_deal_all_alloc);
  scm_c_define_gsubr ("tarot-game-event-get-deal-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_deal_alloc);
  scm_c_define_gsubr ("tarot-game-event-get-decl", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_decl);
  scm_c_define_gsubr ("tarot-game-event-get-discard", 3, 0, 0,
		      tarot_guile_tarot_game_event_get_discard);
  scm_c_define_gsubr ("tarot-game-event-get-discard-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_discard_alloc);
  scm_c_define_gsubr ("tarot-game-event-get-dog", 3, 0, 0,
		      tarot_guile_tarot_game_event_get_dog);
  scm_c_define_gsubr ("tarot-game-event-get-dog-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_dog_alloc);
  scm_c_define_gsubr ("tarot-game-event-get-handful", 3, 0, 0,
		      tarot_guile_tarot_game_event_get_handful);
  scm_c_define_gsubr ("tarot-game-event-get-handful-alloc", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_handful_alloc);
  scm_c_define_gsubr ("tarot-game-event-get-setup", 1, 0, 0,
		      tarot_guile_tarot_game_event_get_setup);
  scm_c_define_gsubr ("tarot-game-event-type", 1, 0, 0,
		      tarot_guile_tarot_game_event_type);
  scm_c_define_gsubr ("tarot-game-event-construct-bid", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_bid);
  scm_c_define_gsubr ("tarot-game-event-construct-call", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_call);
  scm_c_define_gsubr ("tarot-game-event-construct-card", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_card);
  scm_c_define_gsubr ("tarot-game-event-construct-copy", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_copy);
  scm_c_define_gsubr ("tarot-game-event-construct-deal", 3, 0, 0,
		      tarot_guile_tarot_game_event_construct_deal);
  scm_c_define_gsubr ("tarot-game-event-construct-deal-all", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_deal_all);
  scm_c_define_gsubr ("tarot-game-event-construct-deal-all-random", 3, 0, 0,
		      tarot_guile_tarot_game_event_construct_deal_all_random);
  scm_c_define_gsubr ("tarot-game-event-construct-decl", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_decl);
  scm_c_define_gsubr ("tarot-game-event-construct-discard", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_discard);
  scm_c_define_gsubr ("tarot-game-event-construct-dog", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_dog);
  scm_c_define_gsubr ("tarot-game-event-construct-handful", 2, 0, 0,
		      tarot_guile_tarot_game_event_construct_handful);
  scm_c_define_gsubr ("tarot-game-event-construct-setup", 3, 0, 0,
		      tarot_guile_tarot_game_event_construct_setup);
  scm_c_define_gsubr ("tarot-game-iterator-dup", 1, 0, 0,
		      tarot_guile_tarot_game_iterator_dup);
  scm_c_define_gsubr ("tarot-game-iterator-next-value", 1, 0, 0,
		      tarot_guile_tarot_game_iterator_next_value);
  scm_c_define_gsubr ("tarot-game-iterator-construct", 2, 0, 0,
		      tarot_guile_tarot_game_iterator_construct);
  scm_c_define_gsubr ("tarot-mcts-alloc", 1, 0, 0,
		      tarot_guile_tarot_mcts_alloc);
  scm_c_define_gsubr ("tarot-mcts-copy", 2, 0, 0,
		      tarot_guile_tarot_mcts_copy);
  scm_c_define_gsubr ("tarot-mcts-get-best", 1, 0, 0,
		      tarot_guile_tarot_mcts_get_best);
  scm_c_define_gsubr ("tarot-mcts-run", 2, 0, 0, tarot_guile_tarot_mcts_run);
  scm_c_define_gsubr ("tarot-mcts-seed", 2, 0, 0,
		      tarot_guile_tarot_mcts_seed);
  scm_c_define_gsubr ("tarot-mcts-set-base", 2, 0, 0,
		      tarot_guile_tarot_mcts_set_base);
  scm_c_define_gsubr ("tarot-mcts-construct", 2, 0, 0,
		      tarot_guile_tarot_mcts_construct);
  scm_c_define_gsubr ("tarot-mcts-dup", 2, 0, 0, tarot_guile_tarot_mcts_dup);
  scm_c_define_gsubr ("tarot-perceptron-static-default", 0, 0, 0,
		      tarot_guile_tarot_perceptron_static_default);
  scm_c_define_gsubr ("tarot-perceptron-dup", 1, 0, 0,
		      tarot_guile_tarot_perceptron_dup);
  scm_c_define_gsubr ("tarot-perceptron-eval", 5, 0, 0,
		      tarot_guile_tarot_perceptron_eval);
  scm_c_define_gsubr ("tarot-perceptron-learn", 4, 0, 0,
		      tarot_guile_tarot_perceptron_learn);
  scm_c_define_gsubr ("tarot-perceptron-load", 3, 0, 0,
		      tarot_guile_tarot_perceptron_load);
  scm_c_define_gsubr ("tarot-perceptron-save", 3, 0, 0,
		      tarot_guile_tarot_perceptron_save);
  scm_c_define_gsubr ("tarot-perceptron-save-alloc", 1, 0, 0,
		      tarot_guile_tarot_perceptron_save_alloc);
  scm_c_define_gsubr ("tarot-perceptron-set-learning-rate", 2, 0, 0,
		      tarot_guile_tarot_perceptron_set_learning_rate);
  scm_c_define_gsubr ("tarot-perceptron-alloc", 2, 0, 0,
		      tarot_guile_tarot_perceptron_alloc);
  scm_c_define_gsubr ("tarot-predictor-alloc", 0, 0, 0,
		      tarot_guile_tarot_predictor_alloc);
  scm_c_define_gsubr ("tarot-predictor-best", 1, 0, 0,
		      tarot_guile_tarot_predictor_best);
  scm_c_define_gsubr ("tarot-predictor-copy", 2, 0, 0,
		      tarot_guile_tarot_predictor_copy);
  scm_c_define_gsubr ("tarot-predictor-dup", 1, 0, 0,
		      tarot_guile_tarot_predictor_dup);
  scm_c_define_gsubr ("tarot-predictor-eval", 4, 0, 0,
		      tarot_guile_tarot_predictor_eval);
  scm_c_define_gsubr ("tarot-predictor-set-game", 2, 0, 0,
		      tarot_guile_tarot_predictor_set_game);
  scm_c_define_gsubr ("tarot-predictor-construct", 1, 0, 0,
		      tarot_guile_tarot_predictor_construct);
  scm_c_define_gsubr ("tarot-solo-alloc", 0, 0, 0,
		      tarot_guile_tarot_solo_alloc);
  scm_c_define_gsubr ("tarot-solo-alloc-fuzzy", 3, 0, 0,
		      tarot_guile_tarot_solo_alloc_fuzzy);
  scm_c_define_gsubr ("tarot-solo-add", 2, 0, 0, tarot_guile_tarot_solo_add);
  scm_c_define_gsubr ("tarot-solo-copy", 2, 0, 0,
		      tarot_guile_tarot_solo_copy);
  scm_c_define_gsubr ("tarot-solo-copy-as", 3, 0, 0,
		      tarot_guile_tarot_solo_copy_as);
  scm_c_define_gsubr ("tarot-solo-dup", 1, 0, 0, tarot_guile_tarot_solo_dup);
  scm_c_define_gsubr ("tarot-solo-get", 2, 0, 0, tarot_guile_tarot_solo_get);
  scm_c_define_gsubr ("tarot-solo-get-alloc", 1, 0, 0,
		      tarot_guile_tarot_solo_get_alloc);
  scm_c_define_gsubr ("tarot-solo-setup", 7, 0, 0,
		      tarot_guile_tarot_solo_setup);
  scm_c_define_gsubr ("tarot-solo-setup-random", 4, 0, 0,
		      tarot_guile_tarot_solo_setup_random);
  scm_c_define_gsubr ("tarot-solo-construct", 1, 0, 0,
		      tarot_guile_tarot_solo_construct);
  scm_c_define_gsubr ("tarot-xml-parser-alloc", 1, 0, 0,
		      tarot_guile_tarot_xml_parser_alloc);
  scm_c_define_gsubr ("tarot-xml-parser-dup", 1, 0, 0,
		      tarot_guile_tarot_xml_parser_dup);
  scm_c_define_gsubr ("tarot-xml-parser-iterator", 1, 0, 0,
		      tarot_guile_tarot_xml_parser_iterator);
  scm_c_define_gsubr ("tarot-xml-parser-construct", 2, 0, 0,
		      tarot_guile_tarot_xml_parser_construct);
  scm_c_define_gsubr ("tarot-xml-parser-iterator-dup", 1, 0, 0,
		      tarot_guile_tarot_xml_parser_iterator_dup);
  scm_c_define_gsubr ("tarot-xml-parser-iterator-next-value", 1, 0, 0,
		      tarot_guile_tarot_xml_parser_iterator_next_value);
  scm_c_define_gsubr ("tarot-xml-parser-iterator-construct", 2, 0, 0,
		      tarot_guile_tarot_xml_parser_iterator_construct);
  scm_c_define_gsubr ("tarot-card-parse", 1, 0, 0,
		      tarot_guile_tarot_card_parse);
  scm_c_define_gsubr ("tarot-card-parse-c", 1, 0, 0,
		      tarot_guile_tarot_card_parse_c);
  scm_c_define_gsubr ("tarot-card-to-string", 2, 0, 0,
		      tarot_guile_tarot_card_to_string);
  scm_c_define_gsubr ("tarot-card-to-string-alloc", 1, 0, 0,
		      tarot_guile_tarot_card_to_string_alloc);
  scm_c_define_gsubr ("tarot-card-to-string-c", 2, 0, 0,
		      tarot_guile_tarot_card_to_string_c);
  scm_c_define_gsubr ("tarot-card-to-string-c-alloc", 1, 0, 0,
		      tarot_guile_tarot_card_to_string_c_alloc);
  scm_c_define_gsubr ("tarot-cnn-predict", 2, 0, 0,
		      tarot_guile_tarot_cnn_predict);
  scm_c_define_gsubr ("tarot-cnn-predict-alloc", 1, 0, 0,
		      tarot_guile_tarot_cnn_predict_alloc);
  scm_c_define_gsubr ("tarot-cnn-predictor-alloc", 0, 0, 0,
		      tarot_guile_tarot_cnn_predictor_alloc);
  scm_c_define_gsubr ("tarot-cnn-predictor-construct", 1, 0, 0,
		      tarot_guile_tarot_cnn_predictor_construct);
  scm_c_define_gsubr ("tarot-decompose", 1, 0, 0,
		      tarot_guile_tarot_decompose);
  scm_c_define_gsubr ("tarot-features-arff-data", 5, 0, 0,
		      tarot_guile_tarot_features_arff_data);
  scm_c_define_gsubr ("tarot-features-arff-data-alloc", 4, 0, 0,
		      tarot_guile_tarot_features_arff_data_alloc);
  scm_c_define_gsubr ("tarot-features-arff-header", 1, 0, 0,
		      tarot_guile_tarot_features_arff_header);
  scm_c_define_gsubr ("tarot-features-bid-minimum", 1, 0, 0,
		      tarot_guile_tarot_features_bid_minimum);
  scm_c_define_gsubr ("tarot-features-cnn-add", 2, 0, 0,
		      tarot_guile_tarot_features_cnn_add);
  scm_c_define_gsubr ("tarot-features-cnn-alloc", 1, 0, 0,
		      tarot_guile_tarot_features_cnn_alloc);
  scm_c_define_gsubr ("tarot-features-count-faces", 1, 0, 0,
		      tarot_guile_tarot_features_count_faces);
  scm_c_define_gsubr ("tarot-features-count-minor", 1, 0, 0,
		      tarot_guile_tarot_features_count_minor);
  scm_c_define_gsubr ("tarot-features-count-oudlers", 1, 0, 0,
		      tarot_guile_tarot_features_count_oudlers);
  scm_c_define_gsubr ("tarot-features-count-trumps", 1, 0, 0,
		      tarot_guile_tarot_features_count_trumps);
  scm_c_define_gsubr ("tarot-features-errors", 1, 0, 0,
		      tarot_guile_tarot_features_errors);
  scm_c_define_gsubr ("tarot-features-minor-suit", 1, 0, 0,
		      tarot_guile_tarot_features_minor_suit);
  scm_c_define_gsubr ("tarot-features-partner-known", 1, 0, 0,
		      tarot_guile_tarot_features_partner_known);
  scm_c_define_gsubr ("tarot-features-points", 1, 0, 0,
		      tarot_guile_tarot_features_points);
  scm_c_define_gsubr ("tarot-features-position", 1, 0, 0,
		      tarot_guile_tarot_features_position);
  scm_c_define_gsubr ("tarot-features-strongest-player", 3, 0, 0,
		      tarot_guile_tarot_features_strongest_player);
  scm_c_define_gsubr ("tarot-features-team", 1, 0, 0,
		      tarot_guile_tarot_features_team);
  scm_c_define_gsubr ("tarot-features-trick-players", 1, 0, 0,
		      tarot_guile_tarot_features_trick_players);
  scm_c_define_gsubr ("tarot-features-trump", 1, 0, 0,
		      tarot_guile_tarot_features_trump);
  scm_c_define_gsubr ("tarot-features-variant", 1, 0, 0,
		      tarot_guile_tarot_features_variant);
  scm_c_define_gsubr ("tarot-init", 1, 0, 0, tarot_guile_tarot_init);
  scm_c_define_gsubr ("tarot-layout-center", 7, 0, 0,
		      tarot_guile_tarot_layout_center);
  scm_c_define_gsubr ("tarot-layout-center-alloc", 5, 0, 0,
		      tarot_guile_tarot_layout_center_alloc);
  scm_c_define_gsubr ("tarot-layout-hand", 7, 0, 0,
		      tarot_guile_tarot_layout_hand);
  scm_c_define_gsubr ("tarot-layout-hand-alloc", 5, 0, 0,
		      tarot_guile_tarot_layout_hand_alloc);
  scm_c_define_gsubr ("tarot-layout-position", 8, 0, 0,
		      tarot_guile_tarot_layout_position);
  scm_c_define_gsubr ("tarot-layout-trick", 7, 0, 0,
		      tarot_guile_tarot_layout_trick);
  scm_c_define_gsubr ("tarot-layout-trick-alloc", 5, 0, 0,
		      tarot_guile_tarot_layout_trick_alloc);
  scm_c_define_gsubr ("tarot-libtarot-version", 0, 0, 0,
		      tarot_guile_tarot_libtarot_version);
  scm_c_define_gsubr ("tarot-of", 2, 0, 0, tarot_guile_tarot_of);
  scm_c_define_gsubr ("tarot-player-parse", 1, 0, 0,
		      tarot_guile_tarot_player_parse);
  scm_c_define_gsubr ("tarot-player-parse-c", 1, 0, 0,
		      tarot_guile_tarot_player_parse_c);
  scm_c_define_gsubr ("tarot-player-to-string", 2, 0, 0,
		      tarot_guile_tarot_player_to_string);
  scm_c_define_gsubr ("tarot-player-to-string-alloc", 1, 0, 0,
		      tarot_guile_tarot_player_to_string_alloc);
  scm_c_define_gsubr ("tarot-player-to-string-c", 2, 0, 0,
		      tarot_guile_tarot_player_to_string_c);
  scm_c_define_gsubr ("tarot-player-to-string-c-alloc", 1, 0, 0,
		      tarot_guile_tarot_player_to_string_c_alloc);
  scm_c_define_gsubr ("tarot-quit", 0, 0, 0, tarot_guile_tarot_quit);
  scm_c_define_gsubr ("tarot-set-datadir", 1, 0, 0,
		      tarot_guile_tarot_set_datadir);
  scm_c_define_gsubr ("tarot-simulate", 2, 0, 0, tarot_guile_tarot_simulate);
  scm_c_define_gsubr ("tarot-simulate-agreed", 2, 0, 0,
		      tarot_guile_tarot_simulate_agreed);
  scm_c_define_gsubr ("tarot-simulate-random", 2, 0, 0,
		      tarot_guile_tarot_simulate_random);
  scm_c_define_gsubr ("tarot-strategy-bid", 2, 0, 0,
		      tarot_guile_tarot_strategy_bid);
  scm_c_define_gsubr ("tarot-strategy-call-by-length", 2, 0, 0,
		      tarot_guile_tarot_strategy_call_by_length);
  scm_c_define_gsubr ("tarot-strategy-call-marriage", 2, 0, 0,
		      tarot_guile_tarot_strategy_call_marriage);
  scm_c_define_gsubr ("tarot-strategy-call-myself", 2, 0, 0,
		      tarot_guile_tarot_strategy_call_myself);
  scm_c_define_gsubr ("tarot-strategy-discard-by-length", 2, 0, 0,
		      tarot_guile_tarot_strategy_discard_by_length);
  scm_c_define_gsubr ("tarot-strategy-discard-junk", 2, 0, 0,
		      tarot_guile_tarot_strategy_discard_junk);
  scm_c_define_gsubr ("tarot-strategy-discard-save", 2, 0, 0,
		      tarot_guile_tarot_strategy_discard_save);
  scm_c_define_gsubr ("tarot-strategy-excuse", 2, 0, 0,
		      tarot_guile_tarot_strategy_excuse);
  scm_c_define_gsubr ("tarot-strategy-lead", 2, 0, 0,
		      tarot_guile_tarot_strategy_lead);
  scm_c_define_gsubr ("tarot-strategy-outbid", 2, 0, 0,
		      tarot_guile_tarot_strategy_outbid);
  scm_c_define_gsubr ("tarot-strategy-play-points", 2, 0, 0,
		      tarot_guile_tarot_strategy_play_points);
  scm_c_define_gsubr ("tarot-strategy-purity", 2, 0, 0,
		      tarot_guile_tarot_strategy_purity);
  scm_c_define_gsubr ("tarot-strategy-trump-master", 2, 0, 0,
		      tarot_guile_tarot_strategy_trump_master);
  scm_c_define_gsubr ("tarot-string-to-card", 1, 0, 0,
		      tarot_guile_tarot_string_to_card);
  scm_c_define_gsubr ("tarot-string-to-card-c", 1, 0, 0,
		      tarot_guile_tarot_string_to_card_c);
  scm_c_define_gsubr ("tarot-string-to-player", 1, 0, 0,
		      tarot_guile_tarot_string_to_player);
  scm_c_define_gsubr ("tarot-string-to-player-c", 1, 0, 0,
		      tarot_guile_tarot_string_to_player_c);
  scm_c_define_gsubr ("tarot-xml-save", 4, 0, 0, tarot_guile_tarot_xml_save);
  scm_c_define_gsubr ("tarot-xml-save-mcts-tree", 3, 0, 0,
		      tarot_guile_tarot_xml_save_mcts_tree);
}
